2010-05-07 Pierangelo Masarati <masarati@aero.polimi.it>

	* RTAI 3.8.1

2010-05-07 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* rtai-py/rtai_lxrt.py: fix rt_task_delete and rt_thread_delete, to
	  match changes in rtai_lxrt.h (thanks to Chris Cole).  

2010-05-03 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* arch/i386/hal/hal.immed, include/asm-i386/rtai_hal.h, 
	  arch/x86/hal/hail.immed, include/asm-x86/rtai_hal.h: aligned to use 
	  the latest 2.6.32.11 patch support.

2010-05-01 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/rtdm/drvlib.c: fix wrong return value in sems support
	  functions _sem_wait and _sem_wait_timed.

2010-04-21 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/comedi/rtai_comedi.h: in rt_comedi_do_insnlist put the right
	  pointer to data in the passed insnlist arg.

2010-04-16 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/comedi/rtai_comedi.h: grant more appropriate and consistent
	  returns for insn and insnlist executions.

2010-04-13 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scicoslab/macros/RTAI/RTAICodeGen_.sci:
	* rtai-lab/scicoslab/macros/RTAI/SetTarget_.sci: TARGET_DIR
	  set to SCI/contrib/RT_templates.

2010-04-08 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/matlab/rtmain.c: Variable Len for rt_receicex changed to
	  long.
	* configure.in: Added folder scicoslab.
	* rtai-lab/scicoslab/devices/scicos_block4.h:
	* rtai-lab/scicoslab/macros/Makefile:  
	* rtai-lab/scicoslab/macros/RTAI/RTAICodeGen_.sci:
	* rtai-lab/scicoslab/macros/RTAI/RT_templates/rtai.mak:
	* rtai-lab/scicoslab/macros/RTAI/RT_templates/standalone.cmd: 
          Modifications for Scicoslab-4.4.

2010-03-19 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: fixed a never ending loop and a missing unlock
	  in rt_task_suspend_until.

2010-03-18 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/comedi/kcomedi-module.c: set the blocking flag in the calling
	  table of waiting functions, to have them work correctly when called
	  in soft mode.

2010-02-16 Pierangelo Masarati <masarati@aero.polimi.it>

	* RTAI 3.8

2010-02-15 Pierangelo Masarati <masarati@aero.polimi.it>

	* RTAI 3.8-test2

2010-01-25 Joe Brandt <jbrandt@nrao.edu>

	* rtai-lab/matlab/rtmain.c: create MULTITASKING threads in a way
	  that does not depend on whom will resume first.

2010-01-14 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: call rt_thread_delete using rtai_lxrt
	  syscall mode directly in Linux server soft thread.

2010-01-13 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/calibration/smi-module.c and setsmi.in: fix the SMI
	  set/reset procedure (thanks to some remarks by: Ries van Twisk
	  <rtai@rvt.dds.nl>)

2010-01-01 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_schedcore.h: setup OOM killer protection macro,
	  depending on kernel version.
	* base/sched/sched.c, sys.c: use related macro in rtai_schedcore.h 
	  to protect real time tasks from the OOM killer.

2009-12-10 Fernando Augusto <fernando_aug@yahoo.com.br>

	* base/ipc/tbx/tbx.c: fixed a too earlier error return in deleting
	  a tbx.
	* base/ipc/msg/msg.c: fixed a bug related to returnx trying to reply
	  to a timed out rpcing task, without checking its state.

2009-12-01 Pierangelo Masarati <masarati@aero.polimi.it>

	* RTAI 3.8-test1

2009-11-05 Roberto Bucher <roberto.bucher@supsi.ch>
	* rtai-lab/matlab/rtmain.c:
	* rtai-lab/matlab/rtmain.h:
	* rtai-lab/scicoslab/macros/RTAI/rtai_ext_clock.sci:
	* rtai-lab/scicoslab/macros/RTAI/gif_icons/rtai_ext_clock.gif:
	* rtai-lab/scilab/macros/RTAI/rtai_ext_clock.sci:
	* rtai-lab/scila5/macros/RTAI/rtai_ext_clock.sci: Modifications for
	  external synchronization (thanks to Henrik Slotholt).
	* rtai-lab/xrtailab.cpp: 
	* rtai-lab/xrtailab.h: 
	* rtai-lab/Fl_Scopes_Manager.cpp:
	* rtai-lab/matlab/devices/sfun_rtai_scope.c:
	* rtai-lab/scilab5/RTAI/macros/RTAICodeGen_.sci:
	* rtai-lab/scilab/macros/RTAI/RTAICodeGen_.sci:
	* rtai-lab/scicoslab/macros/RTAI/RTAICodeGen_.sci:
	* rtai-lab/sci*/macros/RTAI/rtai4_scope.sci:
	* rtai-lab/sci*/macros/RTAI/rtai4_scope.sci:
	* rtai-lab/scila5/macros/RTAI/rtai4_scope.sci: Modifications for
	  scopes with signal names and double type (thanks to Henrik Slotholt).
	* rtai-lab/sci*/devices/rtai_fifoin.c:
	* rtai-lab/sci*/devices/rtai_fifoout.c: Buffer length set to multiplexed
          of signal size.

2009-11-04 Pierangelo Masarati <masarati@aero.polimi.it>

	* makefile: fix path of kconfig file (thanks to suggestion from
	  Kevin Kemper kemperke at engr.oregonstate.edu)

2009-10-07 Pierangelo Masarati <masarati@aero.polimi.it>
	* addons/drivers/16550A/GNUmakefile.am:
	* addons/drivers/16550A/Makefile.kbuild: fix build out of source tree

2009-10-07 Roberto Bucher <roberto.bucher@supsi.ch>

	* base/include/rtai_lxrt.h: Modified for C++ support.

2009-10-06 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: a few functions for async Linux syscalls
	  renamed, legacy compatibilty maintained, added a few checks more
	  and rt_destroy_linux_syscalls_server.
	* base/include/rtai_sched.h: modified type of the Linux server in 
	  rt_task structure.
	* base/sched/api.c: reworked to check for overruns.
	* base/sched/sched.c: modified call to the Linux async syscalls
 	  server, reworked suspend-resume services.
	* base/sched/sys.c: reworked Linux sycalls server entry, added server
	  cancellation, modified __task_delete to ensure server cancellation.
	* base/include/rtai_lxrt.h: linux server reworked to need no info
	  about registers structure and to support syscalls status inquiries
	  and cancellations.
	* base/schede/api.c: linux server reworked to allow server task
	  working with no info about registers structure and to support 
	  syscalls status inquiries and cancellations.

2009-09-29 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: fix rt_task_suspend_timed if it does timeout, use
	  RTE_TMROVRN in place of RTE_TIMOUT if time is overrunned.

2009-09-25 Valentin Pavlyuchenko <TheValik@gmail.com>
	   Pierangelo Masarati <masarati@aero.polimi.it>
	* base/arch/m68k:
	* base/include/asm-m68k: import of m68k support
	  contributed by Valentin

2009-09-22 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_wrappers.h: define set find_task_by_pid to work
	  with Linux > 2.6.30.
	* base/include/asm-i386/rtai_vectors.h: RTAI_SYS_VECTOR depends on
	  Linux version now, to support changes in latest HALs.

2009-06-28 Paolo Mantegazza <mantegazza@aero.polimi.it>

        * base/arch/i386/hal/immed.c: support CONFIG_X86_32_LAZY_GS for
	  direct vectoring with Linux > 2.6.29.

2009-06-27 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.c: use general hal_processor_id in place of
	  hard_smp_processor_id to avoid Linux version dependencies.
	* base/arch/i386/hal/hal.immed, base/arch/x_86_64/hal/hal_immed: do
	  not set proc entry owner for Linux >= 2.6.30

2009-06-06 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.c: care of Linux version in calling
	  smp_call_function, pointed at by Rodrigo Amestica
	  <ramestica@nrao.edu>

2009-06-19 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab5/RTAI/RT_templates/rtai.mak: Substitute the
          previous wrong file.

2009-06-15 Pierangelo Masarati <masarati@aero.polimi.it>

	* RTAI 3.7.1

2009-06-10 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/macros/RTAI/RT_templates/rtai.mak: 
	* rtai-lab/scicoslab/macros/RTAI/RT_templates/rtai.mak: 
	* rtai-lab/scilab5/RTAI_RT_templates/rtai.mak: Template makefile
	  different for systems with and without COMEDI support.

2009-06-06 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/iarch/i386/hal/hal.c: care of Linux version in calling
	  smp_call_function, pointed at by Rodrigo Amestica
	  <ramestica@nrao.edu>

2009-06-05 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/matlab/devices/sfun_comedi*: Some modifications from
	  Guillaume Millet (from scicos equivalent files).

2009-06-05 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/macros/RTAI/*: 
	* rtai-lab/scilab/devices/*: 
	* rtai-lab/scilab5/devices/*: 
	* rtai-lab/scicoslab/devices/*: Little modifications to avoid
	  compilation warnings.

2009-06-05 Guillaume Millet <millet@isir.fr>

	* rtai-lab/scilab/macros/RTAI/rtai4_comedi*: 
	* rtai-lab/scilab/devices/rtai_comedi*: 
	* rtai-lab/scilab5/RTAI/macros/rtai4_comedi*: 
	* rtai-lab/scilab5/devices/rtai_comedi*: 
	* rtai-lab/scicoslab/macros/RTAI/rtai4_comedi*: 
	* rtai-lab/scicoslab/devices/rtai_comedi*: Little bugs correction.

2009-06-02 Guillaume Millet <millet@isir.fr>

	* addons/comedi/rtai_comedi.h: added comedi_get_subdevice_flags.

2009-05-30 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scicoslab/macros/rtai4_comedi_encoder.sci:
	* rtai-lab/scilab/macros/rtai4_comedi_encoder.sci:
	* rtai-lab/scilab5/macros/rtai4_comedi_encoder.sci:
	* rtai-lab/scicoslab/macros/RTAI-Lib.cosf:
	* rtai-lab/scilab/macros/RTAI-Lib.cosf:
	* rtai-lab/scilab5/macrosRTAI-Lib.cosf:
	* rtai-lab/scicoslab/devices/rtai_comedi_encoder.c:
	* rtai-lab/scilab/devices/rtai_comedi_encoder.c:
	* rtai-lab/scilab5/devices/rtai_comedi_encoder.c: Added subdevices
	  to handle more encoders (many thanks to Guillaume Millet).

2009-05-29 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scicoslab/macros/Makefile: Addesd *.sce to sources to be 
	  copied.
	* rtai-lab/scilab/macros/Makefile: Added *.sce to sources to be copied.

2009-05-20 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sched.h: declare rt_make_hard/soft_real_time for
	  use in kernel space also.
	* base/sched/sys.c: make available rt_make_hard/soft_real_time for
          use in kernel space also, for use in Linux hardened kernel threads.

2009-05-14 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scicoslab/macros/gif_icons/*: Icons for pal tree.

2009-05-14 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scicoslab/loader.sce: 
	* rtai-lab/scicoslab/macros/RTAI/loadmacros.sce:
	* rtai-lab/scicoslab/macros/scilab: New approach in including RTAI files
	  in scicoslab.

2009-05-08 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_schedcore.h: double MAX_WAKEUP_SRQ, we want to be
	  pretty sure it is not overrun.

2009-05-07 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/devices/rtai_log.c: New block for RTAI Logs
	  (thanks to Holger Nahrstaedt).
	* rtai-lab/scilab/macros/RTAI/rtai_log.c: New block for RTAI Logs
	  (thanks to Holger Nahrstaedt).
	* rtai-lab/scilab/macros/RTAI/RTAI-Lib.cosf: New block for RTAI Logs.
	* rtai-lab/scilab/macros/RTAI/RTAICodeGen_.sci: Some adds from new
	  Metalau code generator. 
	* rtai-lab/scicoslab/devices/rtai_log.c: New block for RTAI Logs
	  (thanks to Holger Nahrstaedt).
	* rtai-lab/scicoslab/macros/RTAI/rtai_log.c: New block for RTAI Logs
	  (thanks to Holger Nahrstaedt).
	* rtai-lab/scicoslab/macros/RTAI/RTAI-Lib.cosf: New block for RTAI Logs.
	* rtai-lab/scicoslab/macros/RTAI/RTAICodeGen_.sci: Some adds from new
	  Metalau code generator. 
	* rtai-lab/scilab5/devices/rtai_log.c: New block for RTAI Logs
	  (thanks to Holger Nahrstaedt).
	* rtai-lab/scilab5/RTAI/macros/rtai_log.c: New block for RTAI Logs
	  (thanks to Holger Nahrstaedt).
	* rtai-lab/scilab5/RTAI/macros/RTAI-Lib.cosf: New block for RTAI Logs.
	* rtai-lab/scilab5/RTAI/macros/RTAICodeGen_.sci: Some adds from new
	  Metalau code generator. 

2009-05-05 Pierangelo Masarati <masarati@aero.polimi.it>

	* base/math/Makefile.kbuild: fix compiler header detection

2009-05-03 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: syscalls list reordered to allow 
	  overruns checks server call function, renamed server create, 
	  legacy maintained, delete RTAI task extension when exiting the 
	  Linux syscall server.
	* base/schede/sys.c: ensure the linux syscall server is forced to 
	  exit when deleting its parent RTAI extension.
	* base/schede/api.c: checks Linux async syscalls overruns.

2009-04-30 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: linux server reworked to need no info 
	  about registers structure.
	* base/schede/api.c: linux server reworked to allow server task 
	  working with no info about registers structure.

2009-04-28 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/GNUmakefile.am: Added some files in EXTRA_DIST.
	* rtai-lab/scilab/GNUmakefile.am: Removed README from  EXTRA_DIST.
	* rtai-lab/scicoslab/GNUmakefile.*: Removed from repository.

2009-04-27 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-ppc/rtai_fpu.h, rtai_lxrt, rtai_hal.h: upgraded to
	  work with linux-2.6.29.
	* base/arch/ppc/hal/hal.c: upgraded to work with linux-2.6.29.
	* base/arch/i386/hal/hal.immed and
	* base/arch/x86_64/hal/hal.immed: ensure task flags register returns
	  with interrupt bit cleared from a tick irq.

2009-04-26 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: in rt_change_prio reschedule whenever a self change
	  removes the task from top of the ready list also, accepting a remark
	  from Richly Matthias <Matthias.Richly@student.hpi.uni-potsdam.de>.
	* base/sched/include/rtai_schedcore.h: in pass prio reschedule whenever
	  the top ready task has changed, now it is done if the task receiving 
	  a prio goes to the top.

2009-04-24 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: reschedule immediatly if the caller of
	  rt_task_yield if not at the highest priority.

2009-04-21 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/README.scilab: Install procedures for scilab-4.1.2,
	  scicoslab and scilab-5.1.1
	* rtai-lab/scilab5/*: Removed some duplicated files already installed
	  from folder scilab.
	* rtai-lab/scilab/macros/RTAI/RTAICodegen_.sci:
	* rtai-lab/scilab5/RTAI/macros/RTAICodegen_.sci:
	* rtai-lab/scilab5/RTAI/RT_templates/rtai.mak:
	* rtai-lab/scilab5/RTAI/RT_templates/rtai_sh.mak: Compatibility between
	  different scilab/scicoslab versions.

2009-04-21 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scicoslab/*: Initial files for scicoslab.

2009-04-21 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab5/Makefile: Modified for installing static libraries.
	* rtai-lab/scilab5/libs/scicoslibs.tgz: tarball with static libraries.
	* rtai-lab/scilab5/RTAI/RT_templates/rtai_sh.mak: Additional shared
	  library for Scilab-5.1.1 (thanks to Holger Nahrstaedt).

2009-04-20 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/xrtailab.c, rtai-lab/xrtailab.h: Added some 
	  lock/unlock commands (many tanks to Robert Dye).

2009-04-20 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab5/Makefile, 
	  rtai-lab/scilab5/RTAI/RT_templates/rtai_sh.mak: Choice between
	  generated code with static (default) or shared libraries (thanks to
	  Holger Nahrstaedt).

2009-04-11 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: add args array to struct mode_regs for
	  multiplexed socketcalls.
	* base/sched/api.c: manage multiplexed socketcalls.

2009-04-10 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: rework NONROOT_HRT to align with new way of
	  setting user space permission in Linux > 2.6.28.

2009-04-09 Pierangelo Masarati <masarati@aero.polimi.it>

	* RTAI 3.7

2009-04-09 Valentin Pavlyuchenko <TheValik@gmail.com>
           Paolo Mantegazza <mantegazza@aero.polimi.it>

        * base/ipc/netrpc/netrpc.c: use down_interruptible in send server
	  thread to fix annoying warnings when softlock debugging is 
	  configured in Linux.

2009-04-04 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/netrpc/netrpc.c: rework macro RETURN_ERR to work with 
	  any endianess.

2009-04-03 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: CONFIG_RTAI_INTERNAL_LXRT_SUPPORT
	  has benn useless always, get rid of it, some cleaning more later on.

2009-04-02 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/ppc/hal/hal.c: rework rt_printk and rt_sync_printk.

2009-04-01 Pierangelo Masarati <masarati@aero.polimi.it>

	* configure.in: import from magma support for arm stuff
	  (thanks to Torsten Koschorrek)

2009-03-29 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: anticipate marking a task unblocked before putting
	  it onto the ready.
	* base/ipc/netrpc/netrpc.c: set the return value of soft_rt_fun_call
	  following lxrt mode fully; it wont work on CPUs whose endianness
	  differs from x86 otherwise.

2009-03-28 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_vectors.h: add "memory" gcc-4.3 will 
	  mess it up otherwise.

2009-03-27 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed and base/arch/x86_64/hal/hal.immed,
	* base/include/asm-i386/rtai_lxrt.h and 
	* base/include/asm-x86_64/rtai_lxrt.h: change REG definition macros 
	  to avoid annoying compiler warnings, conflicting with Linux
	  headers.
	* base/include/rtai_scb.h: force RTAI_PROTO to a static inline in 
	  kernel space, otherwise we'll miss scb when RTAI_PROTO is set to 
	  no inline.

2009-03-25 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed and rtc.c,
	* base/arch/x86_64/hal/hal.immed,
	* base/arch/ppc/hal/hal.c:
	  nest RTAI_SCHED_ISR_LOCK/UNLOCK within HAL_LOCK/UNLOCK_LINUX.

2009-03-23 Pierangelo Masarati <masarati@aero.polimi.it>

	* RTAI 3.7-test3

2009-03-23 Pierangelo Masarati <masarati@aero.polimi.it>

	* configure.in: x86_64 does not like -sse2 in kernel space apps
	  (patch by Paul)
	* configure.in: remove more temp files (patch by Paul)
	* makefile: do not override CC var from env (patch by Paul)

2009-03-22 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/netrpc/netrpc.c: do the final cleanup of soft servers by
	  letting them die autonomously on unblock returns.
	* base/sched/sched.c: export rt_daemonize for Linux < 2.6.24, used by
	  netrpc.c.

2009-03-21 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sched.h: define type RT_TASK_INFO and added 
	  declaration of rt_task_get_info.
	* base/include/rtai_lxrt.h: added rt_task_get_info and based 
	  rt_get_priorities onto it.
	* base/sched/api.c: added rt_task_get_info.
	* base/sched/sched.c: reuse rt_get_priorities syscall slot for 
	  rt_task_get_info, add int oneshot_span and initialize it at module
	  init, add macro ONESHOT_DELAY to avoid having the same code twice
	  in the following #if conditioned FIRE_NEXT_TIMER_SHOT macros.

2009-03-20 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab*/RTAICodeGen_.sci: Modifications for
	  compatibility scilab-4.1.2 and scicoslab-4.3.
	* rtai-lab/scilab/macros/RTAI/RT_templates/rtai.mak: 
	  Modifications for compatibility scilab-4.1.2 and scicoslab-4.3.

2009-03-18 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/Kconfig: RTAI_LXRT_USE_LINUX_SYSCALL yessed by
	  default.

2009-03-17 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/wd/README.WATCHDOG: recovered original Ian Soenes doc.
	* base/wd/wd.c: added watchdog for non periodic loopers.
	* base/sched/sched.c: remember previous RTAI tasks in context switches
	  if wd is configured.

2009-03-16 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/addons/drivers/serial/serial.c: save and null callback task 
	  prior to awakening it up in spclose.

2009-03-16 Kenneth Jacker   <khj@cs.appstate.edu>
           Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/wd/wd.c: cleaned legacy stuff being of interest nomore.

2009-03-15 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/addons/comedi/rtai_comedi.h: fixed user space trigger,
	  added helper macro for trigger instruction.

2009-03-14 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed: check to avoid insmoding a 486 MP.

2009-03-13 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/comedi/rtai_comedi.h: add macros to help setting insn up for
	  AI/AO/DIO.

2009-03-12 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/comedi/kcomedi-module.c: fix rt_comedi_wait insertions in 
          the user space call table as data passing is supported internally
	  and not with the use of the general messaging framework.

2009-03-11 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab*/rtmain.c: Bug with rtParam corrected. Thanks
	  to Henrik Slotholt.

2009-03-11 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/msg.c: define and use a macro to check tasks magic.
	* base/ipc/sem.c: define and use a macro to check sems magic.
	* base/ipc/bits.c: define and use a macro to check bits magic.

2009-03-11 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/comedi/kcomedi-module.c, rtai_comedi.h and README: added
	  rt_comedi_trigger and rt_comedi_command_data_write.

2009-03-10 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_posix.h and rtai_signal.h: force a few strict 
	  casts to avoid problems with C++; remove a useless casting 
	  conflicting with C++ when calling a tasklet handler.

2009-03-09 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sched.h: added field resumsg to the task structure,
	  to allow exchanging resume specific flags.
	* addons/comedi/kcomedi-module.c: use the above field to pass callbacks
	  specific values.

2009-03-09 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/comedi/kcomedi-module.c: added rt_comedi_do_insnlist and all 
	  forgotten EXPORT_SYMBOLs; added configurable use of comedi_lock-
	  comedi_unlock for functions that might need it.
	* addons/comedi/rtai_comedi.h: restyled a few lines, fixed 
	  comedi_do_insn and added rt_comedi_do_insnlist.
	* addons/comedi/README: added explanation for what added above.

2009-03-07 Andy Hirsh" <andhirsh@gmail.com>

	* base/include/rtai_fifos.h: add missing declaration of rtf_get_frbs.

2009-03-06 Edoardo Vigoni   <vigoni@aero.polimi.it>
	   Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/comedi/kcomedi-module.c, rtai_comedi.h and README: newly 
	  reworked using rt_task_suspend/resumes to allow checking for
	  overruns; new comedi command read functions embedding callbacks
	  waits and data reading in a single call; updated README.

2009-03-05 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: fix macro rt_task_wakeup_sleeping
	  inconsistency, mask argument not needed.

2009-03-04 Pierangelo Masarati <masarati@aero.polimi.it>

	* RTAI 3.7-test2

2009-03-04 Pierangelo Masarati <masarati@aero.polimi.it>

	* rtai-lab/GNUMakefile.*: only distribute scilab5 stuff by now

2009-03-04 Edoardo Vigoni   <vigoni@aero.polimi.it>
	   Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/comedi/kcomedi-module.c, rtai_comedi.h and README: upgraded
	  to include async operations from user space, working but to be 
	  refined.

2009-03-04 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: disable OOM for all of the RTAI kernel threads.

2009-03-03 Valentin Pavlyuchenko <TheValik@gmail.com>
           Paolo Mantegazza <mantegazza@aero.polimi.it>

        * base/sched/sched.c and base/include/rtai_schedcore.h: fix annoying
          warnings when softlock debugging is configured in Linux, using
	  (TASK_INTERRUPTIBLE | TASK_NOWAKEUP) instead of TASK_INTERRUPTIBLE
	  only.

2009-03-03 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/README_X64: Patches for efltk 64 bit. Thanks to Laurent
	  Boudou.
	* rtai-lab/GNUmakefile.am: Addes scilab5 folder
	* rtai-lab/xrtailab.cpp: Some patches. Thanks to Marco Morandini.
	* rtai-lab/scilab5/*: Added support for Scilab-5.x
	* rtai-lab/scilab/*: Changed some files to increase the name size.

2009-02-27 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_signal.h: use RTAI_PROTO in place of static 
	  inlines to allow its inclusion in libs.
	* base/sched/liblxrt/services.c: include rtai_signal.h in the lib.

2009-02-27 Torsten Koschorrek <devel@koschorrek.com>

	* base/sched/sched.c: move declaration of lnxtsk in rt_signal_wake_up
	  within the following ifdef to avoid warnings.
	* base/sched/sys.c: include oom.h only for Linux versions who have it.

2009-02-22 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/shm/shm.c: use "rtai_shm" in place of "RTAI_SHM" in 
	  struct miscdevice, it avoids a long standing inconsistency with 
	  what used for udev.

2009-02-21 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/calibration/smi-module.c: changes for far back 
	  2.6.xx compatibilty, added reboot notification support.

2009-02-20 Pierangelo Masarati <masarati@aero.polimi.it>

	* base/tasklets/signal.c: removed
	* rtai_signal.ko: no longer built/installed

2009-02-20 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_names.h, rtai_msg.h: remove define of 
	  RTAI_MAX_NAME_LENGTH.
	* base/include/rtai_sched.h: put define of RTAI_MAX_NAME_LENGTH here.
	* base/arch/i386-x86_64/Kconfig: no more conditional inlining.

2009-02-16 Pierangelo Masarati <masarati@aero.polimi.it>

	* RTAI 3.7-test1

2009-02-13 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_wrappers.h: provide macro CONFIG_MMU missing
	  in 2.4.xx

2009-02-12 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/x86_64/hal/hal.immed,
	* base/include/asm-x86_646/rtai_hal.h: commit forgotten changes 
	  to irq_ack to work both with > 2.6.26 and previous releases.

2009-02-12 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed: adapt irq definition in
	  hirq_dispatcher to patches > 2.6.27.

2009-02-10 Pierangelo Masarati <masarati@aero.polimi.it>

	* base/scripts/rtai-load.in: first look for modules in the
	  module dir (patch submitted by Paul, <paul_c@tuxcnc.org>)

2009-02-02 Pierangelo Masarati <masarati@aero.polimi.it>

	* configure.in: only set CROSS_COMPILE if not defined yet

2009-01-29 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386, asm-x86_64/rtai_hal.h modify inline asm
	  in rtai_u64div32c to avoid aliasing warnings with ggc > 4.3.
	* base/arch/i386, x86_64/Kconfig make eager inlines the default to
	  avoid flood of warnings for static inline within extern inline
	  with gcc > 4.3.
	* base/include/rtai_nam2num.h: force RTAI_PROTO to static inline
	  in kernel space, otherwise we'll miss nam2num when RTAI_PROTO
	  is set to no inline.

2009-01-27 Valentin Pavlyuchenko <TheValik@gmail.com>

	* /base/include/rtai_shm.h: make uvirt_to_kva dependent on CONFUG_MMU.
	* /base/include/rtai_lxrt.h: provide dummy rt_grow_and_lock_stack for
	  no CONFIG_MMU.

2009-01-22 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_posix.h: add mode argument in open with O_CREAT
	  and assign write return, to avoid compilation error/warning
	  with ggc > 4.3.
	* base/malloc/malloc.c: undef BLOCK_SIZE in TLSF to avoid a
	  redifinition warning related to Linux headers.

2009-01-19 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: fix rt_get_inher_prio, it returned the base
	  priority in place of the actual one.

2009-01-09 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: make RTAI tasks not OOM killable, if an rt_fun_ext
	  is missing hint to a possible missing module.

2008-12-18 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_wrappers.h and base/include/asm-i386/rtai_hal.h:
	  added bitops missed in 2.4.xx, at the moment used by rtdm only.

2008-12-18 Pierangelo Masarati <masarati@aero.polimi.it>

	* configure.in: check for MMU only meaningful in > 2.4.

2008-12-17 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_fifos.h and base/ipc/fifos/fifos.c: added functions
	  rtf_get_avbs and rtf_get_frbs to get available and free bytes in fifo
	  buffer, extended info structure and related IOCTL request to get the
	  same infos from task not enabled for RTAI.

2008-12-16 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/fifos/fifos.c: set buf type to "const char *" instead of
	  "void *" in all mbx_send functions.

2008-12-15 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_scb.h: added function rt_scb_reset, rt_scb_avbs,
	  rt_scb_frbs.

2008-12-11 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/macros/RTAI/RTAICodeGen_.sci: Modification for
	  future multithread code generation
	* rtai-lab/scilab/macros/RTAI/RT_templates*: New templates fitted
	  for the new Code generator
	* rtai-lab/scilab/rt_main.c: Modified to fit the new Code generator

2008-12-10 Pierangelo Masarati <masarati@aero.polimi.it>

	* rtai-py/, rtai-py/*.py: import python stuff from showroom.

2008-12-10 Pierangelo Masarati <masarati@aero.polimi.it>

	* RTAI 3.7 development cycle starts

2008-12-10 Pierangelo Masarati <masarati@aero.polimi.it>

	* RTAI 3.6-cv

2008-12-05 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/tasklets/tasklets.c: check for non NULL next/prev pointer 
	  at timer and tasklet remove.
	  Thanks to Andy Hirsh" <andhirsh@gmail.com> for pointing at it.

2008-11-25 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_shm.h: fix the comment explaining the returned 
	  value of rtai_malloc and rt_shm_alloc in user space.

2008-11-16 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_wrappers.h,
	* base/include/asm/rtai_hal.h,
	* base/ipc/netrpc/netrpc.c: adapt to 2.6.27.
	* base/ipc/shm/shm.c: turn USE_UDEV_CLASS off, breaks 2.6.27 
	  and likely of no use anywhere.
	* base/arch/i386/hal/hal.immed,
	* base/include/asm-i386/rtai_hal.h: changes to irq_ack to work 
	  both with 2.6.27 and previous releases.

2008-11-16 Pierangelo Masarati <masarati@aero.polimi.it>

	* *.in, configure: complete the insertion of m68knommu arch with all
	  the needed build stuff.

2008-11-15 Valentin Pavlyuchenko <TheValik@gmail.com>

	* /base/include/asm-m68knommu: added m68knommu arch specific include
	  support.
	* /base/arch/m68knommu: added overall m68knommu arch specific
	  directory.
	* /base/arch/m68knommu/hal: added m68knommu arch specific hal.
	* /base/arch/m68knommu/patches: added m68knommu arch specific patches.
	* /base/doc/maintainers/RTAI_mcf5329um.pdf: added mcf5329 porting doc.

2008-11-14 Valentin Pavlyuchenko <TheValik@gmail.com>

	* addons/rtdm/xn.h: care if it is either MMU or not in 
	  strncpy_from_useri and xnarch_remap_vm_page.
	* base/sched/sys.c: VM_PINNED just for the MMU case, care of Linux 
	  version in extending nonroot capabilities.
	* base/include/rtai_lxrt.h: care of growing and locking the stack 
	  in the MMU case only.

2008-11-05 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/macros/RTAI/RTAICodeGen_.sci:Completely rewritten
	  code generator. The code doesn't use dynamic allocation of 
	  structures anymore.
	* rtai-lab/scilab/macros/RTAI/RT_templates*: New templates fitted
	  for the new Code generator

2008-11-03 Pierangelo Masarati <masarati@aero.polimi.it>

	* *.in, configure: regenerate with autoconf 2.61 and automake 1.10

2008-11-03 Pierangelo Masarati <masarati@aero.polimi.it>

	* addons/rtdm/Makefile.kbuild: fix build outside source tree

2008-10-31 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: revert to the previous version of 
	  rt_gettimeorig; thanks to John Ford <jford@nrao.edu>.

2008-10-14 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: change order of mutually exclusive tests
	  in check_to_soften_harden from forcesoft/unlocked/makehard
	  to forcesoft/makehard/unlocked.

2008-10-13 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/malloc/malloc.c: enabled TLSF used_size statistics, fixed
	  macro TLSF_ADD_SIZE, added tlsf_get_used_size.
	* base/sched/sched.c: report global and kstack heaps usage in sched
	  proc file.

2008-10-12 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/rtdm/xn.h: locks reprogrammed as for RTAI own, including 
	  ticket locking for better scalability with more than 2 CPUs.

2008-10-12 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: exploit patch support to block signal when
	  real time hardened tasks transition to Linux because of its
	  signals.

2008-10-11 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/netrpc/netrpc.c: fixed an improper setting of the owner
	  for the port_server in netrpc init.

2008-10-10 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/rtdm: appropriately take into account CONFIG_RTAI_RTDM_SELECT
	  when making.

2008-10-09 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sem.h: define structures to support rt_poll
	  estenxions to any RTAI objects, add rt_poll support for semaphores.
	* base/include/rtai_mbx.h: redefine rt_poll data in mailbox 
	  structure.
	* base/ipc/sem.c: rework rt_poll anew to ease extensions to new 
	  objects to be polled, implement semaphores polling.
	* base/ipc/mbx.c: adapt to reworked rt_poll.

2008-10-07 Paolo Mantegazza <mantegazza@aero.polimi.it> and
	   Bernhard Pfund <bernhard@chapter7.ch> for testing support.

	* base/addons/rtdm/select.c and select.h: inheredited select support.
	* base/addons/rtdm/rtai_taskq.c and rtai_taskq.h: rtai own services
	  to support new select add on.
	* base/addons/rtdm/xn.h: upgraded locks to use tickets, added helpers
	  to support select.
	* base/addons/rtdm/core.c: added RTAI own __rt_dev_select.
	* base/addons/rtdm/module.c: added user space sys interface for
	  RTAI own rt_dev_select.
	* base/addons/rtdm/rtdm.h: added RTAI own rt_dev_select call for 
	  kernel/user space.
	* base/addons/rtdm/device.c, drvlib.c and rtdm_driver.h: upgraded to
	  the lates standard and added select support.
	* base/addons/rtdm/GNUmakefile.am and GNUmakefile.in: modified for
	  making with select.

2008-09-24 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/msg.c: fix missing blocked enqueuing in rt_rpc_until.

2008-09-23 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sem.h: provide rt_poll with error return 
	  if polling is not configured.

2008-09-22 Bernhard Pfund <bernhard@chapter7.ch>

	* base/README.ISOLCPUS: some editing of the existing isolcpus scheme
	  plus a new explanation, with support scripts, to help in using the
	  newer Linux Cpusets & CPU hotplug to isolate CPUs for hard real time
	  only.

2008-09-20 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_shm.h and rtai_wd.h: use RTAI_PROTO macro in 
	  place of forcing "static inline" always.

2008-09-16 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_nam2num.h: use RTAI_PROTO macro in place of 
	  forcing "static inline" always.

2008-08-28 Pierangelo Masarati <masarati@aero.polimi.it>
	* addons/drivers/serial/rtai_serial.h: typo in rt_spset_mcr
	  function declaration; thanks to D Wysong

2008-08-28 Pierangelo Masarati <masarati@aero.polimi.it>
	* configure.in: fix drivers build when no other addon is configured
	  thanks to D Wysong

2008-08-06 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.c: use a hopefully sounder uniform random 
	  generator for synchronizing TSCs.

2008-07-21 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_wrappers: add Linux version dependence for
	  device support with > 2.6.25.
	* base/include/asm-i386/rtai_fpu.h and rtai_hal.h: modified to 
	  support > 2.6.25.
	* base/include/asm-x86_64/rtai_fpu.h: modified to support > 2.6.25.
	* base/sched/sched.c and api.c: put usp_request_rtc under the

2008-07-18 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/Fl_*_Manager.cpp: Modified for compatibility 32/64 bit
	  systems. Thanks to Joe Brandt.

2008-07-11 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_schedcore.h, base/include/rtai_wrappers.h and
	  base/sched/sched.c: use TASK_KILLABLE in place of 
          TASK_UNINTERRUPRIBLE for TASK_HARDREALTIME and TASK_RTAISRVSLEEP.

2008-07-10 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.c: if configured do not enable TSCs sync
	  checking for a single running CPU.

2008-07-09 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/malloc/malloc.c: align TLSF allocator to its distributed 
	  version 2.4.2.

2008-07-08 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/wd/wd.c: use NR_RT_CPUS in declarations only, num_online_cpus()
	  otherwise, get rid of the switch related to scheduler type.
	* base/sched/sched.c: use num_online_cpus(), in place of NR_RT_CPUS,
	  in get_min_tasks_cpuid, Reservoir related stuff and for proc file 
	  reporting.
	* base/arch/i386/hal/hal.immed and base/arch/x86_64/hal/hal.immed:
	  use use num_online_cpus(), in place of RTAI_NR_CPUS, in timer 
	  requests and module initialisation.
	* base/tasklets/tasklets.c and addon/rtdm/module.c: 
	  use num_online_cpus() in timers servers creation/delation.

2008-07-07 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed and base/arch/x86_64/hal/hal.immed:
	  do not insmod RTAI HAL if "num_online_cpus() > RTAI_NR_CPUS".

2008-07-04 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/rtdm/drvilib.c and rtdm_driver.h: added rtdm_task_init_cpuid
	  to allow assigning cpu to tu on at the very task creation.
	* base/sched/sched.c: deregister exiting RTAI own tasks.

2008-07-02 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/rtdm/drvilib.c and rtdm_driver.h: added rtdm task registration
	  deregistration.

2008-06-27 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c and base/include/rtai_lxrt.h: make avoid duplicating
	  rt_printk code in rtai_print_to_screen, just force it to rt_printk
	  alone.

2008-06-19 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: force -EINPROGRESS return for async Linux syscalls 		  processed by a Linux server, leaving the related register unchanged
	  can cause troubles.

2008-06-18 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386-x86_64-ppc/Kconfig: revised CONFIG_RTAI_USI.
	* base/include/rtai_schedcore.h: just indicate USI enabled, since 
	  if so it is embedded always.
	* base/include/asm-i386-x86_64-ppc/rtai_usi.h and
	* base/sched/sched.c and api.c: do not use USI stuff if not configured.

2008-06-18 Pierangelo Masarati <masarati@aero.polimi.it>

	* configure.in: revised CONFIG_RTAI_USI and related issues

2008-06-13 Pierangelo Masarati <masarati@aero.polimi.it>

	* base/scripts/rtai-load.in: /bin/sh compatibility

2008-06-12 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_netrpc.h: fixed wrong arg position assignment 
	  for timeout in all of RT_poll.

2008-06-11 Calin A. Culianu <calin@ajvar.org>. 

	* base/include/rtai_posix.h: fixed a couple of bugs related to 
	  cookie creation and initialisiation in kernel space pthread_create.

2008-06-10 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_posix.h: fixed duplicated macro and add 
	  CLOCKREALTIME/MONOTONIC for posix in kernel space; declare
	  handler_wrpr as static to avoid warning of multiple definitions;
	  fixes pointed by: Paul Stein <stein@cepel.br>.
	* base/include/rtai_wrappers.h; define clockid_t and msleep for 
	  posix in kernel space.

2008-06-09 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/*: Some changes to avoid #include <MODEL>.c

2008-06-08 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* testsuite/user/preempt/preempt.c and display.c: consistently 
	  revised against their counterparts in showrrom.
	* base/sched/sched.c: a few changes to the revised oneshot firing
	  to have it work on older Linux versions.

2008-05-29 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: ensure rt_get_priorities has values to be
	  returned pointers on the stack.

2008-05-25 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/archx86s/hal/hal.immed: use the apic freq from the HAL when 
	  available.

2008-05-24 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/archx86s/hal/hal.immed: discard CLOCKEVENTS if RTC is being
	  used.
	* base/archx86s/hal/rtc.c: revised to work with CLOCKEVENTS.
	* base/sched/sched.c: discard CLOCKEVENTS if RTC is being used.

2008-05-23 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: use macros for common parts of revised oneshot
	  programming; ifdef shots overruns to allow using the old mode for
	  testing.
	* base/archx86s/hal and base/include/asm-x86s: revised, with some
	  cleaning, while porting to 2.6.25.

2008-05-18 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: revised oneshot firing; when the shot has
	  been overrun already we basically avoid causing a timer interrupt
	  by pending a call to the timer handler, which will be served when
	  the task context has been done.

2008-05-13 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: revised hard/soft switches orders following 
	  unblocking, forced soft, trap and Linux syscalls; do not allow
	  deletion from other tasks of the RTAI real time extensions of 
	  Linux sched structs.
	* base/arch/*/hal: redefine lxrt dispatcher arg list to fit sys.c
	  related change.

2008-05-08 Roland Stigge <stigge@antcom.de>

	* base/sched/liblxrt/touchall.c: avoid using Linux "asm/page.h" in
	  user space by calling glibc "getpagesize" to get arch page size.

2008-05-07 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_scb.h: fixed a possible mem leak with user
	  allocated buffers; added put with over write, simplified a few
	  lines of code.

2008-05-06 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/x86_64/hal/hal.immed: grab exceptions as in i386, process
	  floating point enabling immediately.

2008-05-02 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: overwite syscall requests but do not resume the
	  server if it is full already.

2008-04-23 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/drivers/serial/serial.c: just register callbacks and sem 
	  waiters within rt_spisr interrupt handling body, then process them
	  with interrupt fully enabled (CPU flag and PIC) before leaving the
	  handler; reworked _timeout functions.

2008-04-22 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/ppc/hal/hal.c, 
	  base/include/asm-ppc/rtai_atomic.h and rtai_hal.h: updated for use 
	  with the latest Linux versions.

2008-04-21 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/bits.c: changed names of internal static set/clear bits, 
	  conflicting with some Linux definitions (PPC).

2008-04-21 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/drivers/serial/serial.c: enable/disable interrupts at each 
	  multiport loop.

2008-04-20 Renato Castello <zx81@gmx.net>
           Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/drivers/serial/rtai_serial.h: extended definition of ports
	  control structure to support shared interrupts.
	* addons/drivers/serial/serial.c: modified module initialisation
	  and interrupt handler to support shared interrupts.

2008-04-17 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_tasklets.h: implemented tasklets/timers 
	  reservoirs, to make it possible getting/releasing them dynamically
	  in hard real time operations.

2008-04-08 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_tasklets.h: define a user space tasklet struct
	  spanning just the part of the kernel allocated structure needed in
	  user space; add checks for value returned during user space init.
	* base/tasklets/tasklets.c: copy to user space just the needed parts,
	  add some safety tests in registration and support tasklet init.

2008-04-03 Bill Barton <peabody@rahul.net>

	* base/include/rtai_fifos.h and base/ipc/fifos-fisos.c: refurbished 
	  fifo handler stuff.

2008-04-01 Bill Barton <peabody@rahul.net>

	* base/sched/sched.c: ensure traps are catched in kernel space also,
	  through PF_EVNOTIFY for hardened kernel threads and set/clear
	  foreign stack for RTAI own kernel tasks. Indeed Bill's fix is not
	  a first of April Fool.

2008-03-28 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_mq.h and rtai_pmq.h: added a missing RTAI_PROTO
	  in the definition of rt_request_signal_mq.
	  (Pointed at by from Felix Frey" <frey@stettbacher.ch>)

2008-03-14 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_schedcore.h and rtai_prinher.h: cleaned 
	  duplications related to dequeueing ready tasks from resource
	  queues and their renqueing on the ready list, checking if truly
	  ready always.

2008-03-14 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/macros/RTAI/RTAI/*.sci: Set allways dstate=[]
	  to avoid generation of unused code.

2008-03-14 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sched.h: redefine the variable in rt_task_struct
	  used for the busy time alignement of the scheduler with a more 
	  appropriate name.
	  (Following a warning from Paul Corner <paul_c@tuxcnc.org>)
	* base/include/rtai_schedcore.h and
	* base/sched/sched.c: comply to the above change.

2008-03-13 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_schedcore.h: in renq_current check if rt_current 
	  is ready before renqueuing, needed for sure in condvars mutex 
	  releases at least.

2008-03-11 Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/macros/RTAI/RTAICodeGen_.sci: Modified for
	handling some special event blocks.

2008-03-11 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c and sys.c: got rid of Linux smp_processor_id().

2008-03-08 Pierangelo Masarati <masarati@aero.polimi.it>

	* Fix for Module.symvers (thanks to a patch from Paul Corner,
	  <paul_c@tuxcnc.org> )
	* Minor build cleanup

2008-03-06 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_netrpc.h: extend 32/64 operability to kernl/user
	  space remote interactions.
	* base/ipc/netrpc.c: use an inlined function of rtai_netrpc.h to 
	  reset remote adresses.

2008-03-05 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_netrpc.h: set 32nd bit (i.e.: | 0x80000000), in
	  OWNER macro so that there are no 32/64 bits problems.

2008-03-04 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/sem/sem.c and base/ipc/netrpc/netrpc.c: move rt_poll_netrpc
	  from sem.c to netrpc.c.

2008-03-03 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_netrpc.h: updated kernel/user space rt_poll for
	  32/64 interoperability.
	* base/ipc/sem/sem.c: ensure rt_poll_netrpc cares of adapting remote
	  addresses.

2008-03-01 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_netrpc.h: revised for 32/64 bits compatibilty.
	* base/ipc/netrpc.c: revised for 32/64 bits compatibilty.

2008-02-29 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/shm/shm.c: fixed wrong arg passing to rt_shm_alloc_usp 
	  when called from ioct support. 
	  Bug pointed out by: Calin A. Culianu <calin@ajvar.org>. 

2008-02-25 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-x86_64/rtai_hal.h: copy Linux ticket locking for 
	  our recursive rtai_cpu_lock when RTAI_NR_CPUS > 2.
	* base/include/asm-ppc/rtai_hal.h: implement ticket locking in C for 
	  our recursive rtai_cpu_lock when RTAI_NR_CPUS > 2.
	* base/arch/x86_64/hal.immed: rtai_cpu_lock uses an array of 2 unsigned
	  long to allow rtai_cpu_lock to recurse using ticket locking.
	* base/arch/ppc/hal.immed: rtai_cpu_lock uses an array of 2 unsigned
	  long to allow rtai_cpu_lock to recurse using ticket locking.

2008-02-24 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/rtdm/xn.h: reviewed global locks to allow using ticket
	  locking, as/when available in rtai_hals.

2008-02-24 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_hal.h: copy Linux ticket locking for 
	  our recursive rtai_cpu_lock when RTAI_NR_CPUS > 2.
	* base/arch/i386/hal.immed: rtai_cpu_lock uses an array of 2 unsigned
	  long to allow rtai_cpu_lock to recurse using ticket locking.
	* base/sched/sched.c: cleanup and refactor internal sched locks.

2008-02-15 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sched.h: add RT_SCHED_POLL.
	* base/include/rtai_schedcore.h: care of RT_SCHED_POLL in timed
	  wakeups.
	* base/ipc/sem/sem.c: use RT_SCHED_POLL and simplify.

2008-02-14 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/sem/sem.c: rt_poll revised and optimised a bit more.

2008-02-04 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_netrpc.h: modified RT_poll wrappers to use the
	  specific support for rt_poll on netrpc.
	* base/ipc/sem/sem.c: added a specific entry for remote rt_poll.

2008-02-03 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_netrpc.h: modified arg declaratios for user
	  space mail boxes to avoid possible glitches due to an imprecise
	  initialisitaion.

2008-02-02 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/sem/sem.c: added RTAI IPC mechanisms polling support, only
	  MBXes are supported at the moment but the scheme should be ready
	  for everything else needed. The related call is documented with an
	  internal comment.
	* base/include/rtai_sem.h: added declarations required to support
	  rt_poll in kernel user space.
	* base/include/rtai_netrpc.h: added declarations required to support
	  remote usage of rt_poll.
	* base/include/rtai_lxrt.h: added function call number for rt_poll.
	* base/include/rtai_mbx.h: expanded MBX type to include polling
	  queues and lock.

2008-01-31  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/macros/RTAI/rtai4_comedi_data*.sci: Modified 
	the variable "range" to "comedi_range".

2008-01-28 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: allow use of SCHED_OTHER, lost since 3.2,
	  but only by setting it explicitely with rt_task_init_schmod.

2008-01-25 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: our partial daemonization is in Linux exit.c
	  now, for > 2.6.23.

2008-01-20 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: added missing conditional compilation macros
	  for exectime calculations; reorganized the < 2.4.32 stuff;
	  removed IN_INTERCEPT_IRQ_ENABLE (have not been in use for a long
	  time).

2008-01-12  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/macros/RTAI/RTAICodeGen_.sci: Added little
	modificatio from INRIA CodeGen (SVN).

2008-01-11 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-x86_64/rtai_lxrt.h: force a "clts" before 
	  context_switch if the prev task used the FPU.

2008-01-10 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-x86_64/rtai_fpu.h: simplified because xmm is always 
	  there and copied fpu save/restore from Linux.

2008-01-10  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/matlab/rtai.tmf: Modified for Matlab 7.3 and Matlab-7.4.

2008-01-08  Roberto Bucher <roberto.bucher@supsi.ch>

	* configure.in: Deleted the rtai-lab/scilab/devices folder from the
	compilation chain.
	* rtai-lab/scilab/GNUmakefile.am: modified to delete subfolder devices.
	* rtai-lab/scilab/rtmain.c: Version 3.5.1 for scilab-4.1.2.
	* rtai-lab/scilab/macros/builder.sce: Added for better scilab compatibility.
	* rtai-lab/scilab/macros/loader.sce: Added for better scilab compatibility.
	* rtai-lab/scilab/macros/scilab: Startup file for scilab-4.1.2.
	* rtai-lab/scilab/macros/Makefile: New installation file for scilab-4.1.2.
	* rtai-lab/scilab/macros/RTAI/SetTarget_.sci: modified for scilab-4.1.2.
	* rtai-lab/scilab/macros/RTAI/RTAICodeGen_.sci: modified for scilab-4.1.2.
	* rtai-lab/scilab/macros/RTAI/RTAI-Lib.cosf: modified for scilab-4.1.2.
	* rtai-lab/scilab/macros/RTAI/RT_templates/standalone.cmd: modified for
	scilab-4.1.2.
	* rtai-lab/scilab/devices/GNUmakefile.am: Eliminated.
	* rtai-lab/scilab/devices/GNUmakefile.in: Eliminated.
	* rtai-lab/scilab/devices/Makefile: new makefile to generate the libscicos.a
	library
	* rtai-lab/scilab/devices/exit_on_error.c: Added for future HIL simulation.
	* rtai-lab/scilab/devices/*.c: Little modifications for scilab-4.1.2. 

2008-01-06 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/ppc/Kconfig: update the RTDM related part.
	* addons/rtdm/xn.h: defined a missing macro needed for older Linux
	  versions.

2007-12-24 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: anticipate releasing the sched lock before 
	  programming the timer, in the oneshot case.
	* base/include/rtai_shm.h: add macro UVIRT_TO_KVA to shorten usage of
	  the real uvirt_to_kva.
	* base/malloc/malloc.c: restyle memory alloc/freeing and use 
	  uvirt_to_kva directly, through UVIRT_TO_KVA, to avoid redundant 
	  __va(__pa) in res/unreserving pages.
	* base/ipc/shm/kvmem.c: use uvirt_to_kva directly, through 
	  UVIRT_TO_KVA, to avoid redundant __va(__pa) in res/unreserving
	  pages.

2007-12-21 Pierangelo Masarati <masarati@aero.polimi.it>

	* configure.in, configure: allow module versioning for Linux
	  2.6.xx.

2007-12-18 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: when returning from an RTAI own task fully 
	  restate rt_current from rt_smp_current and rtai_cpuid.

2007-12-14 Pierangelo Masarati <masarati@aero.polimi.it>

	* GNUMakefile.am: add udev rules file creation for RTAI shm 
	  and fifos.

2007-12-13 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_wrappers.h: define dummy udev class support.
	* base/ipc/fifos/fifos.c and
	* base/ipc/shm/shm.c: restructured sysfs-devfs stuff.

2007-12-12 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/smi-module.c reworked module inti/cleanup and
	  related infos printout.

2007-12-08 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_signal.h: modified an uncertain, likely compiler 
	  dependent, structure initialisation in requesting a signal.
	* base/include/rtai_mq.h, rtai_pmq.h: as above for notification 
	  handlers.

2007-12-06 Pierangelo Masarati <masarati@aero.polimi.it>

	* configure.in: allow configuration of task switch specific signals.

2007-12-06 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: use configurable parameter to enable/disable
	  signalling of task switches in kernel/user space.

2007-12-05 Pierangelo Masarati <masarati@aero.polimi.it>

	* base/sched/sched.c: use configurable parameter for the stacks heap
	  size of RTAI own kernel tasks.

2007-12-04 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* all archs Kconfigs: add configurable parameter for the stacks heap
	  size of RTAI own kernel tasks.

2007-11-13 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/bits.c and base/include/rtai_bits.h: changed return type 
	  from "int" to "unsigned long" in rt_bits_reset, is 64 bits safer.

2007-11-13 Bernd Suessmilch <Bernd.Suessmilch@uibk.ac.at>

	* base/ipc/bits.c: return the latest mask always.

2007-11-03 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: made RTAI own real time signals a native 
	  service; reinstalled task signals at context switch using 
	  RTAI signals simmetrically in kernel/user space, while 
	  maintaining compatibility with the old kernel space only method.
	* base/sched/signal.c: modified as neede to be native RTAI services.
	* base/include/rtai_lxrt.h: defined signals syscalls numbers as part i
	  of the basic RTAI services.
	* base/include/rtai_signal.h: use new signals syscalls numbers, part 
	  of the basic RTAI services now.
	* base/include/rtai_mq.h, rtai_pmq.h: changed named of signals related 
	  syscalls names.

2007-11-02 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_posix.h: reworked a few lines, to impose L1 
	  cache alignment to the task allocation in kernel pthread_create.

2007-11-01 Bernd Suessmilch <Bernd.Suessmilch@uibk.ac.at>

	* base/ipc/bits.c: ensure the correct value is returned when a task
	  is blocked in any of the bits_wait.

2007-10-30 Pierangelo Masarati <masarati@aero.polimi.it>

	* /base/arch/i386/calibration/smi-module.c: fix module naming.
	* /base/arch/i386/calibration/setsmi: set hal_smi_masked_bits during
	   set/reset.

2007-10-28 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: start/stop_rt_timer care of being done 
	  in soft mode.

2007-10-24  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab: Modifications for Scilab-4.1.2

2007-10-21 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-x86_64/rtai_hal-h: upgrades for using latest kernel 
	  patching.
	* base/arche/x86_64/hal/hal.immed: upgrades for using latest kernel 
	  patching.

2007-10-19 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: force mlockall internally at task initting.

2007-10-16 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: rt_thread_create/join adapted to 
	  pthread_create thread return in NPTL
	* base/include/rtai_tasklets.h, base/tasklets/tasklets.c: adapted
	  to what returned above.

2007-09-22 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: do not init task_trap_handler for setting lxrt 
	  extension anymore.
	* base/usi/usi.c, base/tasklets/tasklets.c, base/ipc/fifos/fisos.c:
	  set lxrt extensions with the due set/rest functions, 
	  task_trap_handler is dead.

2007-09-05 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immedi, base/include/asm-i386/rtai_hal.h,
	* base/arch/x86_646/hal/hal.immed, base/include/asm-x86_646/rtai_hal.h:
	  get rid of hal_pended alltogether.

2007-09-02 Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_hal.h: revised and unified 
	  hal_pend_uncond for all Linux versions.
	* base/malloc/malloc.c: added TLSF based allocator, optionally
	  set at RTAI config.

2007-08-31  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/matrixx/GNUmakefile.am:  Modified to allow compilation from
	  an external folder.
	* rtai-lab/matrixx/GNUmakefile.in:  Modified to allow compilation from
	  an external folder.

2007-08-26  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/rtmain.c: Changed type for rt_BaseTaskPeriod to
	  RTIME.
	* rtai-lab/matlab/rtmain.c: Changed type for rt_BaseTaskPeriod to
	  RTIME.
	* rtai-lab/matrixx/rtmain.c: Changed type for rt_BaseTaskPeriod to
	  RTIME.
	* rtai-lab/matrixx/rtmain.h: Changed version.

2007-08-24  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/fifos/fifos.c: allow using fifos without any RTAI 
	  scheduler, unsetting macro "LXRTEXT" by hand.
	* base/include/asm-i386/rtai_vectors.h: restructured to work with 
	  both 2.4.xx and 2.6.xx.
	* base/include/rtai_wrappers.h: added a few define and a type not 
	  existing in 2.4.xx.
	* addons/rtdm/module.c: deleted inclusion of the useless cpumask.h,
	  conflicting with 2.4.xx.

2007-08-23 Pierangelo Masarati <masarati@aero.polimi.i>

	* RTAI 3.5 closure version

2007-08-23  Martin Plattl <martin.plattl@knapp.com>

	* base/ipc/fifos/fifos.c: fixed a wrong test using free space in 
	  place of available bytes in mbx_receive_if

2007-08-21  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* testsuite/user/latency/latency.c: do not display execution time 
	  statistics when the related feature is not configured.

2007-08-20  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed: check both hal_pended and pipe root
	  stall flag in all of RTAI internal direct vectoring handlers.

2007-08-19  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: optimise EXEC_TIME calculations, modify
	  various "is_hard" tests to have it more appropriately.

2007-08-12  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: make rt_set_period SMP safe.

2007-08-07  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_lxrt.h: define TIMER_TYPE as arch
	  dependent feature here.
	* base/sched/sched.c: define TIMER_TYPE to one, but only if it is
	  not defined as an arch specific feature already; fix, partially
	  rewrite and simplify _rt_linux_hrt_next_shot.

2007-08-05  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/addons/rtdm/module.c: remove long unused TRUE_LXRT_WAY.
	* base/addons/rtdm/rtdm.h: remove long unused TRUE_LXRT_WAY and
	  manage ENOSYS caused transitions from hard to soft mode
	  automatically.

2007-08-04  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/x86_64/hal/hal.immed and base/arch/ppc/hal/hal.c: 
          export IsolCpusMask for possible use in RTDM.

2007-08-03  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/addons/rtdm/core.c, core.h, device.c, device.h, drvlib.c,
	  module.c, proc.c, rtdm.h, rtdm_driver.h, rtserial.h, xn.h, 
	  internal.h: updated to the last.
	* base/addons/drivers/16550A/16550A.c, 16550A_io.h, 16550A_pnp.h:
	  updated to the last.
	* base/arch/i386/hal/hal.immed: export IsolCpusMask for possible use
          in RTDM.

2007-08-02  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/tasklets/tasklets.c: reworked and shortened reinsertion of 
	  periodic timers after firing in the timer manager.

2007-07-27  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i385/hal/hal.immed, 
	* base/arch/x86-64/hal/hal.immed: use IRQF_SHARED in place of SA_SHIRQ
	  it will avoid depracation warnings with the most recent Linux
	  versions.
	* base/include/rtai_wrappers: set defined IRQF_SHARED to SA_SHIRQ for
	  older Linux version still using it.

2007-07-26  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/x86-64/hal/hal.immed: modified to support CLOCKEVENTS, 
	* base/include/asm-x86_64/rtai_fpu.h: thread_info disappeared from
	  post Linux 2.6.20, use task_thread_info instead.
	* base/include/asm-x86_64/rtai_lxrt.h: include asm-x86-64/asm-offests.h 
	  to ensure "__NR_syscall_max" is available.
	* base/include/asm-x86_64/rtai_vectors.h: test correct definition of 
	  RTAI_SYS_VECTOR in "__KERNEL__" only.

2007-07-24  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: TIMER_TYPE macro must be set depend on 
	  CONFIG_GENERIC_CLOCKEVENTS also in the UP case.

2007-07-20  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_hal.h: remove declarations for 
	  request/release of Linux hrt tickdev, needed nomore.
	* base/arch/i386/hal/hal.immed: request/release of Linux hrt tickdev 
	  unified here, function pointers for hrt mode and oneshot setting 
	  declared and exported so that sched.c can set them later.
	* base/sched/sched.c: request/release of linux hrt moved to hal.immed,
	  initialise hrt mode and oneshot setting pointers exported from 
	  hal.immed.

2007-07-15  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed: added support for using hard timers
	  without any RTAI scheduler, in periodic mode only; needed mainly
	  to keep some existing tests working.
	* base/include/asm-i386/rtai_hal.h: added declarations for the use
	  of what above.

2007-07-11  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_fpu.h: thread_info disappeared from
	  post Linux 2.6.20, use task_thread_info instead.
	* base/include/asm-i386/rtai_hal.h: copy Linux do_div locally.
	* base/include/asm-i386/rtai_vectors.h: include header to get a macro 
	  from the patch.
	* base/include/asm-i386/rtai_lxrt.h: add macro to pend local apic 
	  interrupts to Linux when it uses clockevents.
	* base/arch/i386/hal/hal.immed: add macro for a dummy bradcast to 
	  local apics when Linux uses clockevents.
	* base/sched/sched.c: add support for Linux clockevents.

2007-06-19  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/macros/Makefile: Changed the scilab version to 4.1.1.

	* rtai-lab/scilab/macros/RTAI/CodeGen_.sci: Eliminated some unused
	  functions.

2007-06-14  Paolo Mantegazza <mantegazza@aero.polimi.it>
            	
	* base/ipc/netrpc.c: care of stubs being soft/hard when deleting 
	  those left behind at module exit.

2007-06-13  Pierangelo Masarati <masarati@aero.polimi.it>
	    Antonio Barbalace <barbalace@igi.cnr.it>

	* x86_64 scheduler build back to mainstream:
		- rtai_lxrt/rtai_sched on x86_64 as on all other archs

2007-06-12  Antonio Barbalace <barbalace@igi.cnr.it>

	* base/include/asm-x86_64:rtai_sched.h: multiversion, the one to be 
	  used to be decided yet.
	* base/arch/x86_64/hal/hal.immed and base/arch/i386/hal/hal.immed: 
	  added rt_eoi_irq for APIC interrupts.

2007-06-07  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/devices/*.c: Added copyright lines in the sources.

2007-06-04  Antonio Barbalace <barbalace@igi.cnr.it>
	    Paolo Mantegazza <mantegazza@aero.polimi.it>
            	
	* base/sched/sched.c: use unsigned long in place of int for 
	  rt_smp_linux_cr0, to work with for 64 bits archs also.

2007-06-04  Antonio Barbalace <barbalace@igi.cnr.it>
            	
	* base/include/asm-x86_64/rtai_sched.h: fixed support for context
	  switches of RTAI own kernel tasks.

2007-06-01  Emanuele Clerici <clerici@aero.polimi.it>

	* base/ipc/mq.c: check possible return error of mutex locking and
	  use timed mutex locks in timed send/receive.

2007-05-30  Emanuele Clerici <clerici@aero.polimi.it>

	* base/include/rtai_pmq.h and rtai_mq.h: added declarations for 
	  notify support.
	* base/ipc/mq.c: added notify support.

2007-05-25  Lennart.C. Karssen <l.c.karssen@phys.uu.nl>
	    Paolo Mantegazza <mantegazza@aero.polimi.it>

        * addons/comedi/rtai_comedi.h: fixed a missing initialisation of the 
	  local (on stack) copy of bits in comedi_dio_bitfield.

2007-05-25  Emanuele Clerici <clerici@aero.polimi.it>

	* base/include/rtai_lxrt.h: added syscall numbers for Posix MQ
	  notification from user space.
	* base/include/rtai_signal.h: added a few declarations to allow using
	  RTAI signals for Posix MQ notification.
	* base/include/rtai_tasklets.h: added extensions for using RTAI 
	  tasklets to support Posix timers.
	* base/include/rtai_posix.h: revised kernel space part for
	  compatibility with user space references, added Posix timers.
        * base/tasklets/signal.c: added a few controls more, support for MQ
	  specific notification, moved a couple of declarations to the
	  rtai_signal.h.
	* base/tasklets/tasklets.c: added extensions for using tasklets to
	  support Posix timers.
	* base/posix/POSIX_WRAPS: added due wrappers for timers.

2007-05-24  Paolo Mantegazza <mantegazza@aero.polimi.it>
            	
	* base/include/asm-x86_64/rtai_hal.h: simplify rtai_ulldiv, on a 64 
	  bits arch it comes "by nature".

2007-05-22  Paolo Mantegazza <mantegazza@aero.polimi.it>
            	
	* base/include/rtai_msg.h, rtai_netrpc.h and 
	  base/ipc/msg.c: use a pointer to a long for the received msg length 
	  in extended evdrp and receive.

2007-05-22  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/rtai4_comedi_data*.sci: Changed the name
	  of the variable range to comedi_range to avoid conflicts
	  with a scilab function.

2007-05-12  Paolo Mantegazza <mantegazza@aero.polimi.it>
            	
	* base/ipc/shm.c: enable heap shearing parts only if 
	  CONFIG_RTAI_MALLOC has been set.

2007-05-11  Paolo Mantegazza <mantegazza@aero.polimi.it>
            	
	* base/malloc/malloc.c: set system allocation support as a variable in 
	  the calling args list of any function needing it.
	* base/include/rtai_malloc.h: divert rt_malloc/free to kmalloc/free if 
	  RTAI mallocing is not configured, define new prototypes with type
	  of Linux allocation support.
	* base/include/rtai_schedcore.h: sched_malloc/free needed no more.
	* base/sched/sched.c: use a specific allocation for kernel stacks of 
	  RTAI proper kernel tasks.
	* base/tasklests/tasklests.c: get rid of useless sched_malloc/free 
	  defines and use rt_malloc/free instead.
	* base/ipc/shm/shm.c: use the new rtheap_init call prototype.
	* base/ipc/mbx/mbx.c: use rt_malloc in place of the now dead 
	  sched_malloc.

2007-05-10  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/matlab/rtai.tmf: Some changes needed for Matlab
	  >= 2006b (thanks to Emanuele Clerici)

2007-05-08  Emanuele Clerici (clerici@aero.polimi.it)

	* base/include/rtai_netrpc.h and base/ipc/netrcp.c: cleaned undue 
	  constraint on the number of stubs being power of 2.

2007-05-06  Antonio Barbalace <barbalace@igi.cnr.it>
	    Paolo Mantegazza <mantegazza@aero.polimi.it>
            	
	* base/include/asm-ppc,
	  base/arch/ppc: support of RTAI for PPC fully upgraded to Linux 
	  2.6.xx, i.e. kernel and user space are now working for PPC also.

2007-05-05  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: possible RTAI execution of Linux signal handlers
	  in sys.c made architecture dependent.
	* base/include/asm-allarch: define macros for architecture dependent
	  execution of Linux signal handlers in sys.c.

2007-05-02  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_netrpc.h,
	* base/ipc/netrpc.c: made arch independent with respect to endiannes.

2007-04-16  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: ensure correct returns in the switch part of 
	  lxrt invoke whatever the endianess.

2007-04-12  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: switch to soft mode if in rt_thread_create
	  a thread is created while being in hard mode, recovering it after
	  thread creation.

2007-04-04  Emanuele Clerici (clerici@aero.polimi.it)

	* base/ipc/netrpc/netrpc.c: fixed glitches in stub/slots management, 
	  changed soft recvfrom prototype to match its hard counterpart.
	* base/ipc/netrpc/rtnetP.h: changed soft recvfrom prototype declaration
	  to match its hard counterpart.

2007-03-29  Paolo Mantegazza <mantegazza@aero.polimi.it>

        * base/arch/i386/hal/hal.immed and base/arch/x86_64/hal/hal.immed:
	  function "rtai_broadcast_to_local_timers" broadcasts to ALLBUT 
	  cpus and pends to Linux locally, to avoid a useless interrupt.

2007-03-27  Paolo Mantegazza <mantegazza@aero.polimi.it>

        * base/ipc/netrpc/netrpc.c: force asmlinkage using a variable 
	  number of args for in kernel net syscalls, older compilers seem to 
	  have it not with just asmlinkage.

2007-03-18  Paolo Mantegazza <mantegazza@aero.polimi.it>

        * base/arch/i386/hal/hal.immed: support for Linux > 2.6.19 in direct
          vectoring and RTAI proper syscalls, requires push/pop of gs and the
          loading of KERNEL_PDA segment, a forgot to commit; this new version
	  avoids duplicated code for vectored isrs by using a macro.

2007-03-15  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: fixed a few remaining arguments list incongruences 
	  for high numbered user space calls from 64 bits machines.

2007-03-08  Emanuele Clerici (clerici@aero.polimi.it)

	* base/ipc/netrpc/netrpc.c: fixed two wrong comparisons in get_stub.

2007-03-07  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/sem/sem.c: atomic_cmpxchg replaced with cmpxchg in 
	  spinlocks.

2007-03-04  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: clean an ifdef in wakeup_srq_handler that was
	  for x86_64 only.
	* base/include/rtai_schecore.h: check that virqs for waking up Linux 
	  tasks are in sequence (i.e.: virq(i) = virq(0) + i).

2007-03-03  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/comedi/rtai_comedi.h: enabled for use with 32/64 bits 
	  architectures.

2007-03-02  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: make immediate internal Linux syscalls 
	  architecture dependent through LXRT_DO_IMMEDIATE_LINUX_SYSCALL macro.
	* base/include/asm-???/rtai_lxrt.h: define architecture spacific
	  LXRT_DO_IMMEDIATE_LINUX_SYSCALL macro.

2007-03-01  Pierangelo Masarati <masarati@aero.polimi.it>

	* reworked scheduler build:
		- rtai_lxrt/rtai_sched on all archs;
		- rtai_lxrt only on x86_64
		- all symlinks including legacy on all archs

2007-03-01  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/msg/msg.c: cast macros to long, in msg_not_sent-received,
	  to be consistent with 64 bits address casting,

2007-02-28  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/drivers/serial/rtai_serial.h: revised to be usable with 64 bits
	  archs also.

2007-02-28  Pierangelo Masarati <masarati@aero.polimi.it>

	* revised x86_64 build (Kconfig, defconfig...).

2007-02-26  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_lxrt.h: rewrote Linux syscall server 
	  creation and support function to allow both sync and async serving;
	  added a function for changing sync_async mode and callback function.
	* base/include/asm-i386/rtai_sched: changed Linux syscall server type 
	  in task struct to support both sync and async serving.
	* base/sched/sys.c: rewrote Linux syscall server creation to support 
	  both sync and async serving.
	* base/sched/api.c: rewrote Linux syscall server calling to support 
	  both sync and async serving; added a function for changing 
	  sync_async mode and callback.
	* base/sched/sched.c: modified assignement of Linux syscall server 
	  in task structure and call table to support both sync and async 
	  serving.

2007-02-26 Pierangelo Masarati <masarati@aero.polimi.i>

	* RTAI 3.5 release

2007-02-25  Roberto Bucher <roberto.bucher@supsi.ch>

	*/rtai-lab/scilab/macros/RTAI/:RTAICodegen_.sci: Some changes to
	run under Windows

2007-02-14  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_lxrt.h: task context switching 
	  compatibility with new fpu support in linux > 2.6.19.

2007-02-10  Paul Corner <paul_c@tuxcnc.org>

	* base/ipc/fifos/fifos.c: fix udev related ifdefs.

2007-02-09  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/macros/RTAI/SetTarget_.sci,
	*/rtai-lab/scilab/macros/RTAI/:RTAICodegen_.sci: Corrected bug with 
	non existent TARGET_DIR (again!).
	*/rtai-lab/scilab/macros/RTAI/:RTAICodegen_.sci: Eliminated the string
	substitution '-' -> '_' for the generation folder.


2007-02-09  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: avoid a deprecation for linux > 2.6.19.
	* base/ipc/netrpc/netrpc.c: use sys call table directly to cope
	  with missing _syscalls definitions for linux > 2.6.19.
	* base/include/asm-i386/rtai_hal.h: force REGPARM always for 
	  linux > 2.6.19.

2007-01-19  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/macros/RTAI/SetTarget_.sci,
	*/rtai-lab/scilab/macros/RTAI/:RTAICodegen_.sci: Corrected bug with 
	non existent TARGET_DIR.

2007-01-15  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/Kconfig: added parameter to configure CLOCK_REALTIME 
	  usage in a few RTAI native timing functions, to avoid a likely
	  negligible overhead when it is not needed.
	* base/sched/api.c: support CLOCK_REALTIME in rt_wait_until and 
	  rt_make_periodic, using REALTIME2COUNT.
	* base/ipc/sem.c: support CLOCK_REALTIME in rt_sem/cond_wait_until,
	  using REALTIME2COUNT.
	* base/include/rtai_posix.h: clock functions support for both 
	  CLOCK_MONOTONIC and CLOCK_REALTIME.

2007-01-14  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sched.h: added declarations of functions: 
	  rt_get_real_time and rt_get_real_time_ns.
	* base/include/rtai_lxrt.h: added codes and calls from user space
	  for functions: rt_get_real_time and rt_get_real_time_ns.
	* base/include/rtai_schedcore.h: added macro REALTIME2COUNT, to 
	  support timing functions called with real time arguments, but only
	  if specifically configured.
	* base/sched/sched.c: all start_rt_timer functions prepare epoch origin
	  for possible real time support; added rt_get_real_time and 
	  rt_get_real_time_ns.
	* base/sched/api.c: expand rt_gettimeorig to generate epoch origin.
	* base/sched/sys.c: support use of NULL argument in rt_gettimeorig,
	  to update epoch origin from user space.

2007-01-12  Mattia Mattaboni (mattaboni@aero.polimi.it)

	* rtai-lab/matrixx/ Makefile, rtmain.c, rtmain.h: latest updates to 
	  support IO devices (analogue/digital)

	* rtai-lab/matrixx/devices/rtai_led.c, rtai_log.c, rtai_meter.c,
	  rtai_scope.c: revised with some return checks more.

	* rtai-lab/matrixx/devices/rtai_comedi_datain.c, rtai_comedi_dataout.c,
	  rtai_comedi_dioin.c, rtai_comedi_dioout.c: new devices to support IO 
	  (analogue/digital).

	* rtai-lab/matrixx/rtaidevs/*: palettes/icons to personalise RTAI 
	  palettes/icons to personalise RTAI devices in SystemBuild.

	* rtai-lab/matrixx/examples/DAQtest.rtf, IOtest.rtf: something to
	  show IO (analogue/digital) at work.

2007-01-11  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/rtmain.c,
	*/rtai-lab/matlab/rtmain.c: : rt_rpc replaces rt_send+rt_task_suspend
	in the rtBaseRate procedure.

2007-01-11  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: lxrt_intercept_schedule_tail needs not to return
	  anything, typed void.

2007-01-10  Paolo Mantegazza <mantegazza@aero.polimi.it>
            Roberto Bucher <roberto.bucher@supsi.ch>
	
	* base/sched/api.c: avoid suspends only if the task owns resource
	  semaphores, before it did not suspend if sent messages were pending 
	  also.

2007-01-08  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/mq/mq.c: msgsize checked without any lock, fixed queue
	  head resetting in receiving functions; ensured queue mutex is
	  unlocked always; use mq_curmsgs as an index in get/freeing nodes,
	  nodind is redundant; simplify a few tests.
	* base/include/rtai_mq.h: makes available POSIX compliant returns,
	  by setting errno. It depends on the definition of the internal macro:
	  USE_POSIX_ERRNO, which is set by default. Users used to getting errno
	  directly should comment it off; get rid of redundant variable nodind.
        * base/sched/sched.c: do not execute Linux syscalls internally if a
          signal is pending; recast a, forgotten, dynamic link to rt_sem_signal 
	  to support Linux REGPARM; do not steal from Linux if a signal is 
	  pending, just remind it to the next RTAI call (is_hard = -1).
	* base/include/rtai_netrpc.h: safer support of receive buffer sizes
	  in user space asynchronous support (rt_get_net_rpc_ret).
	* base/ipc/netrpc.c: get rid of unused/redundant stuff in local
	  mbx support for asynchronous returns.
	* base/include/rtai_tbx.h and
	  base/ipc/tbx/tbx.c: fixed missing support for Linux REGPARM of
	  broadcasting functions.

2006-12-27  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.c: fixed spinlocks definition to support
	  TSCs synchronisation for 2.4.xx also.
	* base/arch/i386/hal/hal.immed: ifdef redundant MODULE_LICENSE to
	  avoid complaint with 2.4.xx.

2006-12-26  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sched.h,
	* base/include/rtai_schedcore.h,
	* base/sched/api.c,
	* base/sched/sched.c, get rid and clean up of RT_SCHED_SELFSUSP state 
	  stuff, used no more.
	* base/sched/sched.c: reworked sched locking to set/reset 
	  rt_scheduling.rqsted more appropriately.

2006-12-23  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_srq.h,
	  base/include/asm-i386/rtai_usi.h,
	  base/arch/i386/hal/hal.immed,
	  base/sched/sched.c,
	  base/arch/i386/Kconfig: 
	  catching of syscall prologue in rtai_hal for full symmetric usage
	  of Linux syscall mechaninsm, RTAI own srqs and APIs, when it is 
	  configured.

2006-12-22  Emanuele Clerici (clerici@aero.polimi.it)

	* base/include/rtai_netrpc.h: adapted to support new netrpc extensions.
	* base/ipc/netrpc/netrpc.c: added timeouts and dynamic recovery of
	  lost ports (network downs); revised registry.
	* base/ipc/netrpc/README: rewritten and revised to explain new/modified
	  services.

2006-12-22  Mattia Mattaboni (mattaboni@aero.polimi.it)

	* rtai-lab/matrixx/rtmain.*: support for meters and leds.
	* rtai-lab/matrixx/devices: added meters and leds.
	* rtai-lab/matrixx/README: explain new devices usage.

2006-12-21  Mattia Mattaboni (mattaboni@aero.polimi.it)

	* rtai-lab/matrixx/rtmain.*: adaption of existing rtmains to support
	  Matrixx autocode generated programs.
	* rtai-lab/matrixx/rtai.tpl: reworked for RTAI-Lab existing template 
	  file in Matrixx.
	* rtai-lab/matrixx/sa_utils.*: reworked corresponding existing files
	  in Matrixx for better interoperability within RTAI-Lab.
	* rtai-lab/matrixx/devices: Matrixx UCBs for RTAI-Lab scopes and logs.
	* rtai-lab/matrixx/examples: a couple of examples to demonstrate
	  Matrixx working with RTAI-Lab.

2006-12-21  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* rtai-lab/matrixx/vxwoks-wrappers: utility headers to allow an easy
	  modification of Matrixx templates, without too much retyping.

2006-12-21  Pierangelo Masarati <masarati@aero.polimi.it>

	* rtai-lab/matrixx/mxp.*: support services for Matrixx parameters 
	  naming, setting and getting on the fly through RTAI-Lab.
	* rtai-lab/matrixx/Makefile: first draft for the making of an 
	  application.

2006-12-21  Pierangelo Masarati <masarati@aero.polimi.it>

	* making support for Matrixx committed to CVS, in rtai-lab/matrixx.

2006-12-18 RTAI-3.4 closure version released, 3.5 begins in VULCANO.

2006-12-18  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/macros/RTAI/rtai_fifo.sci: Added for 
	compatibility with old versions.

2006-12-18  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_tasklets.h, base/include/rtai_wd.h,
	  base/include/rtai_signal.h,
	  base/tasklets/tasklets.c, base/tasklets/signal.c,
	  base/wd/wd.c: all changed to allow using Linux with REGPARM enabled.
	* base/include/rtai_schedcore and base/sched/sched.c: try to avoid 
	  useless reschedules when changing the priority of a ready task.

2006-12-17  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/devices/olddevices.c: extract the COMEDI functions.
	* /rtai-lab/scilab/devices/old_comedi.c: Compatibility with old version 
	  for comedi functions.

2006-12-17  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed: added user space specific code for
	  pending linux irqs (usr_rt_pend_linux_irq).

2006-12-16  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: set is_hard for an RTAI task being stolen from
	  Linux before calling schedule, simplified fast_schedule.

2006-12-15  Pierangelo Masarati <masarati@aero.polimi.it>

	* add support to keep Linux task priority aligned to RTAI, structure
	  the new way for setting RTNet availability, do not halt making RTAI
	  when LINUX REGPARM is set, RTAI supports it now.

2006-12-14  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/Kconfig: define the new way for setting RTNet 
	  availability.
	* base/ipec/netrpc/netrpc.c: use properly the new way of defining 
	  RTNet availability.

2006-12-13  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: simplified Linux schedule tail, it can be called 
	  just within Linux so let's avoiding a useless test.

2006-12-12  Roberto Bucher <roberto.bucher@supsi.ch>

	* /addons/comedi/kcomedi-module.c: Modified the file for REGPARM.
	* /addons/comedi/rtai_comedi.h: Modified the file for REGPARM.

2006-12-12  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/devices/rtai_fifoin.c: Added block for FIFO input.
	* /rtai-lab/scilab/macros/RTAI/rtai_fifoin.sci: Added block for FIFO input.
	* /rtai-lab/scilab/devices/rtai_fifoout.c: Added block for FIFO output.
	* /rtai-lab/scilab/macros/RTAI/rtai_fifoout.sci: Added block for FIFO output.
	* /rtai-lab/scilab/macros/RTAI/RTAI-Lib.cosfi: Modified Scicos Palette.

2006-12-10  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/drivers/serial/rtai_serial.h, addons/drivers/serial/serial.c,
	  addons/rtdm/module.c;
	* base/include/rtai_bits.h, base/include/rtai_fifos.h, 
	  base/include/rtai_mbx.h base/include/rtai_mq.h, 
	  base/include/rtai_msg.h, base/include/rtai_netrpc.h,
	  base/include/rtai_proxies.h, base/include/rtai_registry.h,
	  base/include/rtai_rwl.h, base/include/rtai_sched.h,
	  base/include/rtai_schedcore.h, base/include/rtai_sem.h,
	  base/include/rtai_shm.h, base/include/rtai_spl.h,
	  base/include/rtai_tbx.h;
	* base/include/asm-i386/rtai_hal.h;
	* base/ipc/bits/bits.c, base/ipc/fifos/fifos.c, base/ipc/mbx/mbx.c,
	  base/ipc/mq/mq.c, base/ipc/msg/msg.c, base/ipc/netrpc/netrpc.c,
	  base/ipc/sem/sem.c, base/ipc/shm/shm.c base/ipc/tbx/tbx.c;
	* base/sched/api.c base/sched/sched.c base/sched/sys.c: 
	  all of the aboves changed to allow using Linux with REGPARM enabled.

2006-12-09  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_hal.h and 
	  base/arch/i386/hal.immed: wipe unused legacy code related to 
	  UNWRAPPED_CATCH_EVENT away.
	* base/sched/sched.c: use a more meaningful klist name for going hard,
	  wipe unused legacy code related to UNWRAPPED_CATCH_EVENT away.

2006-12-07  Paolo Mantegazza <mantegazza@aero.polimi.it>

        * base/sched/sched.c: reset soft level priorities in give_back_to_linux,
	  simplify enqueuing of ready soft task on the ready list.
        * base/sched/sys.c: avoid a double test by duplicating a single line
	  in rtai_lxrt_invoke.

2006-12-06  Paolo Mantegazza <mantegazza@aero.polimi.it>

        * base/arch/i386/Kconfig: add configurable parameter to enable keeping
	  soft real time linux tasks priority aligne to RTAI.
        * base/sched/sched.c: add code to support what above.

2006-12-05  Paolo Mantegazza <mantegazza@aero.polimi.it>

        * base/sched/sched.c: added support for getting linux tasks tid, 
	  i.e. the unique one.

	* base/include/rtai_posix.h, base/include/rtai_lxrt.h: added RTAI 
	  own functions for getting linux tasks tid.

	* base/include/asm-i386/rtai_hal: make hard irq bit state tests 
	  visible everywhere, make linux irq request neutral with respect
	  to kernel changes, it is up to the user to use the right prototype.

	* base/arch/i386/hal/hal.immed.c: changes to comply to the latest 
	  hal patches and Linux release (2.6.19).

2006-12-04  Paolo Mantegazza <mantegazza@aero.polimi.it>

        * base/ipc/bits/bits.c, base/ipc/netrpc/netrpc.c, base/ipc/sys/sys.c:
	  base/include/rtai.h, base/include/rtai_wrappers.h: avoid inclusion 
	  of linux/config.h, dismissed in 2.6.19, checked it gives no problem
	  down to 2.4.33.

	* base/include/rtai_sem.h: fix a name conflict introduced by 
	  Linux 2.6.19 (rt_mutex_init).

	* base/include/rtai_hal_names.h: comply to name changes in hal patches
	  (from 2.6.19).

        * base/ipc/fifos/fifos.c, base/ipc/shm/shm.c: avoid inclusion of 
	  linux/devfs_fs_kernel.h and linux/config.h, dismissed in 2.6.19, 
	  checked down to 2.4.33.

2006-12-04  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/matlab/rtmain.c: Changed the macro TASKPERIOD
	to TASKDURATION.

2006-12-04  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/rtmain.c: Changed the macro TASKPERIOD
	to TASKDURATION.

2006-12-04  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/macros/RTAI/RT_templates: renamed
	stdalone.cmd to standalone.cmd.

2006-11-30  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/macros/RTAI/RT_templates: Added the gen 
	file for the original INRIA standalone code generation.

2006-11-30  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/macros/RTAI/RTAICodeGen_.sci: Added the 
	possibility 	have the target files in a local directory (to be 
	specified as TARGET_DIR 	in the .scilab file.

2006-11-30  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/rtmain.c: Implemented the structure to 
	measure the 	task duration. This measure must be activated 
	by adding by hand a new 	compilation flag (-DTASKPERIOD) to 
	the compilation flags. The variable RTTSKper contains the task 
	duration and can be elaborated by a scicos 	block.

2006-11-30  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/matlab/rtmain.c: Implemented the structure to 
	measure the task duration. This measure must be activated 
	by adding by hand a new 	compilation flag (-DTASKPERIOD) to 
	the compilation flags. The variable RTTSKper contains the task 
	duration and can be elaborated by a S-Function.

2006-11-22  Emanuele Monari <emonari@system-group.it>

	* /base/ipc/msg/msg.c: fixes incongruences in documentation.
	
2006-11-20  Paul Corner <paul_c@tuxcnc.org>

        * /base/scripts/rtai-load.in: use INT in place of SIGINT, should be
	  more general and portable.
	
2006-11-10  Paolo Mantegazza <mantegazza@aero.polimi.it>

        * /base/ipc/netrpc.c: do label current (current->comm) if the hard 
	  stub is an RTAI own kernel task.

2006-11-09  Paulo Stein <stein@cepel.br>

        * /base/include/rtai_posix.h: for kernel space: fixed an improper
          use of "pshared" in sem_init and redefined a lost MAX_PRIO macro
          again.

2006-11-08  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/macros/RTAI/RTAI-Lib.cosf: Changed the path 
	saved in the file (probably not necessary...)

2006-11-08  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /addons/rtdm/module.c: added smp_mb() at the end of
	  xnintr_synchronize to avoid computer locks at irq
	  detach when shared irqs are enabled.

2006-11-07  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /include/rtai_sched.h: extended error codes to include netrpc timeout.

2006-11-07  Pierangelo Masarati <masarati@aero.polimi.it>

	* configure.in: allow to configure RTAI_DIAG_TSC_SYNC,
	  RTAI_MASTER_TSC_CPU and RTAI_TUNE_TSC_SYNC

2006-11-06  Pierangelo Masarati <masarati@aero.polimi.it>

	* configure.in: allow to configure RTAI_RTDM_EDGE_SHIRQ,
	  RTAI_RTDM_LEVEL_SHIRQ and RTAI_DEBUG_RTDM;
	  refresh of all build files

2006-11-05  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /addons/rtdm/* and /addons/drivers/16550.c: aligned to the latest.
	* /base/ipc/shm/shm.c: use TSKEXT1, properly restoring it after being 
	  used, in place of TSKEXT3 for mapping to user space.
	* /base/include/rtai_hal_names.h: added #error check for TSKEXTs, to
	  avoid memory leaks in case hal patches change the related sizing;
	  reworked hal_schedule_back_root stuff for proper use of "prev", as
	  set from within "context_switch".

2006-11-04  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/include/rtai_hal_names.h: check task extensions (through macro
	   TSKEXT0) to avoid memory leaks in case of hal patches changing of 
	   what set in Linux task struct.

2006-11-02  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/arch/i386/hal/hal.immed: use existing hal-linux support for 
	  changing Linux real time scheduling policy and rt_priority for 
	  2.6.xx.

2006-11-01  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/include/rtai_hal_names.h,
	* /base/include/asm-i386/rtai_hal.h: adapted to the new definition of 
	  hal domains through Linux per_cpu stuff.

2006-10-27  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/devices/*.c: function getstr changed to
	par_getstr (conflict with a Scilab function). Thanks to
	Simone Mannori.

2006-10-26  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/macros/RTAI/rtai4_comedi_datain.sci: Corrected
	bug by passing block parameters. Thanks to Simone Mannori.

2006-10-20  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/matlab/rtmain.c: Added a hiddean feature to measure the
	task duration using a compiler flag "-DTASKPERIOD=<fifo nr>.

2006-10-20  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/rtmain.c: Added a hiddean feature to measure the
	task duration using a compiler flag "-DTASKPERIOD=<fifo nr>.

2006-10-05  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/sched/sched.c: do not return hard immediately if a signal is 
	  pending after a Linux syscall made in hard mode, use the final part
	  of Linux return processing by returning -1.

2006-10-04  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/macros/RTAI/RTAI-Lib.cosf: Corrected the absolute
	  path contained in the palette.

2006-10-04  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/scilab/rtmain.c: Better handling of the Ctrl-C signals 
	  on certain systems.

2006-10-04  Roberto Bucher <roberto.bucher@supsi.ch>

	* /rtai-lab/matlab/rtmain.c: Restored the previous mechanisms to
	synchronize the tasks.

2006-09-28  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/ipc/sem.c: check broadcasted task handle to keep the lazy
	   atomicity safe.

2006-09-27  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/ipc/fifos.c: fixed atomic rtf_get_if, it called the internal 
	  support for rtf_put_if.

2006-09-26  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/arch/i386/Kconfig: add configuration for TSC diagnose and
	  synchronisation.
	* /base/include/asm-i386/rtai_hal.h:
	* /base/arch/i386/hal/hal.c, hal.immed: use confugiration parameters
	  for TSC synchronisation.

2006-09-25  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/include/asm-i386/rtai_hal.h:
	* /base/arch/i386/hal/hal.c, hal.immed: diagnose of TSCs offsets,
	   though hal proc display, a possible correction already in place.

2006-09-19  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/include/rtai_posix.h: push a cleanup function to decrement
	  the mated mutex usage count when a waiting condvar is destroyed.

2006-09-18 RTAI-3.4 released.

2006-09-14  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/tasklets/tasklets.c: update the actual time by reading the
	  timer, postpone actual priority assignment when it is sure it will
	  be used (avoids spurious preemptions), do not let the idle sleep 
	  priority to go below the (user assignable) default threshold.

2006-09-12  Mathias Koehrer <mathias_koehrer@arcor.de>
	    Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/ipc/sem/sem.c: appropriately test suspension of delation of
	  a task owning a resource semaphore by using the due macro.
	* /base/sched/sched.c: use the due macro to set suspension of delation 
	  of a task owning a resource semaphore.

2006-09-12  Mathias Koehrer <mathias_koehrer@arcor.de>

	* /testsuite/user/preempt/preemt.c.c: use a volatile to suite stricter 
	  optimization needs for gcc-4.1.3.

2006-09-10  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/tasklets/tasklets.c: create per cpu timers manager at the 
	  highest priority, but make available the related value as a 
	  module parameter.

2006-09-06  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/mbx/mbx.c: always signal sems on error returns from 
	  mbx_wait and mbx_wait_until, to allow reuse of the mailbox on
	  restarting from signals.

2006-09-03  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/mq/mq.c: modified cond_var usage, with a simpler internal, 
	  there is no need for a true cond_wait behaviour.

2006-09-02  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/sem/sem.c: deleted useless count keeping in cond_wait 
	  functions.
	* base/include/rtai_pmq.c: added to substitute rtai_mq.h to return 
	  error values as required by POSIX.

2006-08-31  Roberto Bucher <roberto.bucher@supsi.ch>
2006-08-31  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/msg/msg.c: fixed a wrong check of proxy address in case 
	  of abnormal return.

2006-08-31  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_prinher.h: added macros to ascertain resources 
	  ownership accordingly to the configured priority inheritance mode.
	* base/sched/sched.c, api.c: use due macros to ascertain resuorces 
	  ownership whatever the configured priority inheritance mode.

2006-08-30  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: do not care Linux priorities when waking up a 
	  SCHED_NORMAL soft real time task, for users doing it on their own.
	* base/sched/api.c, sys.c: ensure that soft priority and policy of a 
	  linux syscall servers are aligned with those of its master.
	* base/sched/api.c: revised rt_change_prio.
	* base/include/rtai_schedcore.h: revised pass_prio.
	  An almost common layout for both of the aboves.

2006-08-29  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: check priority and base priority independently
	  when setting/recovering soft values in transitioning hard/soft/hard.
	* base/ipc/msg.c: rt_receive_if on blocked send made as its non if
	  conterpart, the priority recovery was missing.

2006-08-28  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/drivers/166550: updated to the latest.
	* addons/rtdm: updated to the latest.

2006-08-27  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/sem/sem.c: ensure priority inheritance also for RES_SEM 
	  of restype RESEM_BINSEM, it was forgotten. 

2006-08-26  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: added function to get priority and base_priority,
	  all at once.
	* base/include/rtai_lxrt.h and rtai_sched.h: added declarations to
	  support what above.

2006-08-25  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: set the state of a newly RTAI enabled user space 
	  task to 0 in __task_init. Otherwise there could be cases in which 
	  other tasks can infer a wrong status. Discovered so lately likely 
	  because such a condition comes "by nature" if the new task uses 
	  an RTAI service before other tasks interfere with its state. 

2006-08-24  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/rtdm/rtdm_driver.h: make timeout < 0 mean rt_sem_wait_if in
	  _sem_wait_timed.

2006-08-16  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/rtmain.c: Reinserted rt_send
	* rtai-lab/matlab/rtmain.c: Reinserted rt_send

2006-08-14  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_posix.h: more posix compliant return in rwloc
	  unlock.
	* base/ipc/sem/sem.c: check semtype, not only owndby, when resetting 
	  prios at wake up in sem_waits; signal wrlock only if owned and 
	  return RTE_EPERM in rt_rwl_unlock if called without anything to do.

2006-08-13  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/matlab/rtmain.c: Replaced send/receive for synchronisation
	between rtBaseRate and rtMain with a semaphore (thanks to G. Palli).

2006-08-13  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/: Changed most of the file because of the new Code 
	generator (Universal Code generator) and porting of the Scicos functions 
	from type "2004" to type "4". The new scicos block interfaces have the 
	name rtai4_xxxxxxxx. The old one (rtai_xxxxxx) are still provided for
	compatibility with old block diagrams.

2006-08-12  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_posix.h: better enforce cancellation points
	  in sems and conds wait.

2006-08-10  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_posix.h: further enhance adherence to the
	  standard for spin locks.

2006-08-07  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: rework LXRT rwl_init to take into account its
	  type.
	* base/ipc/sem.c: manage "restype" (recursive, ewrrorcheck, normal).
	  Transform rt_rwl_init to rt_typed_rwl_init, to allow typed 
	  rwlockers. Full backward compatibility kept for all.


2006-08-06  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sem.h: add "restype" to the RTAI semaphore
	  structure.
	* base/include/rtai_types.h: add "restype" macros.
	* base/include/rtai_rwl.h: changes declarations and users space call
	  of rt_rwl_init to rt_typed_rwl_init; rt_rwl_init compatibility 
	  kept through a macro.
	* base/include/rtai_posix.h: further enhance adherence to the
	  standard.

2006-08-05  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sched.h,rtai_sem.h,rtai_types.h: macros and 
	  declarations extensions to support non recursive RES_SEMs types 
	  also.

2006-08-04  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_posix.h: revised user space posix interface 
	  (see the many tests in showroom).
	* base/ipc/sem.c: fix wrong return value in rt_rwl_delete.
	* base/sched/sys.c: extend use of __task_init to move user space 
	  tasks to a cpus_allowed.

2006-08-01  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/sem.c: do not let unlocking of RES_SEM, either by non 
	  owner or by owner if unlocked already; reset recursion depth only 
	  for RES_SEM in rt_cndmtx_signal; reorder return values in cond_wait 
	  and cond_wait_until.

2006-07-31  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/: Changed most of the file because of the new Code 
	generator (Universal Code generator) and porting of the Scicos functions 
	from type "2004" to type "4". The new scicos block interfaces have the 
	name rtai4_xxxxxxxx. The old one (rtai_xxxxxx) are still provided for
	compatibility with old block diagrams.

2006-07-31  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: __task_init returns immediately the available 
	  task extension if already set.
	* base/ipc/sem.c: barrier returns mark the unleashing task and 
	  unlished tasks with different values; typed named semphore 
	  initialization tell if it existed already.
	* base/include/rtai_sem.h, rtai_posix.h: declarations of typed named
	  semaphores redifined according to the new prototype.
	* base/include/rtai_sched.h: add permission error definition.

2006-07-23  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_posix: added a few APIs related to timing
	  functions to improve plain POSIX compatibility (see posix user 
	  examples in showroom, new sem_clock added also).

2006-07-18  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_posix.h: adapted to the new --posix-wrap making,
	  that allows to use standard Posix APIs names for what RTAI supports.

2006-07-17  Pierangelo Masarati <masarati@aero.polimi.it>

	* add --posix-wrap support to rtai-config, so that it is possible to
	  use supported plain Posix APIs names, i.e. without the need of
	  postpending "_rt".
	* add new /base/posix directory and POSIX_WRAPS support file.

2006-07-12  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm/rtai_shm: simplified by avoiding useless 
	  assignements.
	* base/ipc/shm.c: modified mapping of v/k-malloced shared memory to
	  use the latest for > 2.6.14, found in Linux (drivers/media/video).

2006-07-08  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_tasklets.h, base/ipc/sem/sem.c, base/sched/api.c:
	  cleaned faky/misleading documentation comments.

2006-07-07  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: revised all "stop_rt_timer", to remove 
	  forgotten dead code; ensure period is zero in "start_rt_timer"
	  when oneshot mode is assigned at starting the timer.

2006-07-05  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_hal.h: declare support structure for
	  interrupts handling here.
	* base/arch/i386/hal/hal.immed and base/sched/api.c: remove redundant 
	  local declarations of support structure for interrupts handling and 
	  use the one defined in arch specific rtai_hal.h.

2006-06-28  Matthijs ten Berge <m.h.tenberge@alumnus.utwente.nl>

	* base/include/rtai_lxrt.h: use vsnprintf in place of vsprintf
	  to guard against possible memory leaks.

2006-06-26 RTAI-3.4-test1 released.

2006-06-23  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_schedcore.h: added common support for linux 
	  syscalls from hard real time, according to the setting of the
	  new parameter CONFIG_RTAI_IMMEDIATE_LINUX_SYSCALL.
	* base/include/asm-i386/rtai_lxrt.h: removed i386 specific support 
	  for linux syscalls from hard real time.

2006-06-23  Pierangelo Masarati <masarati@aero.polimi.it>

	* default of RTAI_SCHED_LXRT_NUMSLOTS set to 150
	* added check for syntax compliance of RTAI_RTDM_FD_MAX
	* added configure/Kconfig support for RTAI_IMMEDIATE_LINUX_SYSCALL

2006-06-22  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_wrappers.h: added support to use the newer
	module param declarations keeping them conpatible with 2.4.xx.
	* what above propagated to the all files needing it.
	* base/include/asm-i386/rtai_atomic.h: revised for a better
	  consistency.
	* what above propagated to the all files needing it.

2006-06-18  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: ensure full look ahead in finding hashed 
	  names/adres when there are search collisions.

2006-06-17  Paolo Mantegazza <mantegazza@aero.polimi.it>

        * base/include/rtai_hal_names.h: define the fourth task extension,
	  i.e. TSKEXT3.
        * base/ipc/shm.c: use TSKEXT3 to keep the link for mmapping a user
	  space allocated shared memory.

2006-06-16  Pierangelo Masarati <masarati@aero.polimi.it>

	* beginning of RTAI 3.4 release process.

2006-06-15  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/ipc/fifos.c: use a module parm to decide if an LXRT extension 
	  should be created or not.

2006-06-11  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: fixed the test to reposition a blocked task in a 
	  prioq after a priority change.

2006-06-10  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/drivers/serial/rtai_serial.h: stricter typing in struct
	  supporting the call to callback function management.

2006-06-09  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: adjust priorities for RTAI tasks going hard,
	  in steal_from_linux, before they are stolen from Linux.

2006-06-02  Pierangelo Masarati <masarati@aero.polimi.it>

	* added RTDM_FD_MAX as Kconfig parameter

2006-06-01  Pierangelo Masarati <masarati@aero.polimi.it>

	* Cleanup suggested by Paul <paul_c AT tuxcnc DOT org>
	  (mostly GNUmakefile.am install paths; silence warnings;
	  add #!bin/sh to scripts and so).

2006-05-31  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sys.c: safer return to user space of what returned by 
	  rt_gettimeorig.

2006-05-30  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: fixed wrong priority changed, that did not allow
	  less prioritary changes.

2006-05-23  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/rtdm/rtdm_driver.h: fixed wrong test in 
	  rtdm_strncpy_from_user.

2006-05-23  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* testsuite/user/switches/switches.c and 
	* testsuite/kern/switches/switches.c: added taskswitching time 
	  measures for intertask rpc/receive/return.

2006-05-14  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed: make available module parms for 
	  either printing or not fpu init/trap warnings, default is no.

2006-05-11  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_lxrt.h: fixed unused stack allocation when 
	  rt_thread_create, user space only, uses clone.
	* base/arch/i386/Kconfig: present direct vectoring and scheduling 
	  configuration options unconditionally.

2006-05-08  Bernd Gassmann <gassmann@fzi.de>

	* base/sched/sched.c: export switch_time for independent use, but 
	  only if execution time monitoring is configured.

2006-05-08  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/rtmain.c: Fit new xrtailab with automatic Log.

2006-05-07  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/matlab/setup.m: Automatically compile the C-Mex S-Function.
	Thanks to Arno and Giampy.

2006-05-05  Bernd Gassmann <gassmann@fzi.de>

	* base/include/rtai_sched.h: add declaration of periodic_resume_time
	  in task structure.
	* base/sched/api.c and sched.c: keep an independent resume time in
	  all functions involved in periodic tasks scheduling.

2006-05-04  Bernd Gassmann <gassmann@fzi.de>

	* base/ipc/sem/sem.c: fix possible deadlock conditions in 
	  rt_rwl_unlock.

2006-05-04  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/devices: request_port substituted by request_port_id 
	  in sem and mbx files.

2006-05-04  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/macros/RTAI/RTAICodeGeneration_.sci: Solved problem
	  with "_" in model name.
	* rtai-lab/scilab/macros/RTAI/rtai_mbx_rcv_if.sci: Changed default 
	  values in parameter dialog.
	* rtai-lab/scilab/macros/RTAI/rtai_mbx_rcv.sci: Changed default values
	  in parameter dialog.
	* rtai-lab/scilab/macros/RTAI/rtai_sem_wait.sci: Changed default values
	  in parameter dialog.

2006-05-01  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_schedcore.h: changed test for priority passed 
	  to a task further blocked either on sems or intertask messages.

2006-04-27  Alberto Sechi <albertosechi@libero.it>
	
	* /rtai-lab/Fl_Scope_Window.cpp, /rtai-lab/Fl_Meter_Window.cpp
	  /rtai-lab/Fl_Synch_Window.cpp, /rtai-lab/Fl_Led_Window.cpp, 
	  /rtai-lab/Fl_Params_Manager.cpp: adjusting of windows dimensions
	  after profiles loading
	* /rtai-lab/matlab/rtmain.c: max comedi devices changed to 10

2006-04-27  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed, rtc.c: no need to use atomic bit 
	  setting on return from interrupt handling/dispatching.
	* base/ipc/mbx/mabx.c: safer direct acquisition of acces semaphores 
	  in all nonblocking send/receive.

2006-04-25  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/devices: request_port_id substituted by request_port 
	  in sem and mbx files.

2006-04-24  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_netrpc.h: deleted useless argument from the call 
	  list of named sem/mbx inniting.

2006-04-19  Alberto Sechi <sechi@aero.polimi.it>

	* addons/comedi/rtai_comedi.h, Kcomedi-module.c: added
	  comedi_data_read_delayed() support.

2006-04-18  Pierangelo Masarati <masarati@aero.polimi.it>
	* base/sched/GNUmakefile.am: reworked scheduler build; only
	  build rtai_sched and rtai_lxrt, create symlinks to legacy
	  schedulers.

2006-04-17  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: reordered the test for searching the next 
	  oneshot firing, to avoid useless searches.

2006-04-15  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_hal.h: revised support for switching 
	  back-forth Linux.
	* base/arch/i386/hal/hal.immed, rtc.c: use new switching back-forth 
	  Linux, when Linux locking is set directly from real time interrupts
	  handling;
	* base/sched/sched.c: use new switching back-forth Linux.

2006-04-15  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/rtdm/core.c, core.h, module.c, proc.c: updated to the latest.

2006-04-12  Alberto Sechi  <sechi@aero.polimi.it>

	* base/iarch/i386/calibration/smi-module.c: added missing
	  rthal_smi_disable before return in smi initting.

2006-04-10  Jan Kiszka  <jan.kiszka@web.de>

	* addons/drivers/16550A/16550A.c: Fix leaking lock in 
	  rt_16550_read().

2006-04-10  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed: deferred scheduling in interrupt
	  handlers (if configured) wraps Linux locking.
	* base/sched/sched.c: do not call rt_schedule if locked in deferred
	  suspend.

2006-04-07  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* drivers/16550A/16550A.c: updated to the latest.
	* rtdm/core.c, rtdm/device.c, rtdm/device.h, rtdm/drvlib.c,
	  rtdm/module.c, rtdm/proc.c, rtdm/rtdm_driver.h, rtdm/xn.h,
	  rtserial.h: updated to the latest.

2006-04-05  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sched.h: added self suspend state.
	* base/sched/api.c: defer non self suspending to the scheduling
	  functions.
	* base/sched/sched.c: care of rescheduling deferred suspends.

2006-03-30  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_wd.h: added user space extension declarations.
	* base/wd/wd.c: added entries table for user space.
	* README.LXRT_EXT_IN_USE: added info about the watchdog extension.

2006-03-27  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_tasklet.h: care of forcing to soft a hard task
	  initting a tasklet/timer. 
	* base/sched/sys.c: allow NULL for checking soft/hard real time mode 
	  of the current task.

2006-03-22  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed: allow changing the default irq ack.
	* base/arch/i386/Kconfig: added configuration and helper for the new 
	  error returns of blocking functions.
	* base/include/rtai_bits.h, rtai_msg.h, rtai_sched.h, rtai_sem.h,
	  rtai_schedcore.h: defines and cleanups to support configuring 
	  return errors, chosing between the legacy and new scheme.
	* base/sched/api.c: new configurable error returns and revision of 
	  suspend services.
	* base/sched/sys.c: new configurable error returns and revision of 
	  the LXRT function calls layout.
	* base/sched/sched.c: new configurable error returns support.
	* base/ipc/bits/bits.c, ipc/mbx/mbx.c, ipc/msg/msg.c, ipc/sem/sem.c,
	  ipc/netrpc/netrpc.c, base/ipc/tbx/tbx.c: new configurable error 
	  returns.

2006-03-21  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include-i386/asm/rtai_hal.h: added declarations to support 
	  simple acks for the 8259A PIC.
	* base/arch/i386/hal/hal.immed: added support for simple acks for 
	  the 8259A PIC
	* base/arch/i386/patches/hal-linux-2.6.15-i386-1.2-01.patch, 
	  hal-linux-2.6.14-i386-1.1-02.patch,
	  hal-linux-2.4.32-i386-1.1-01.patch: export i8259 spinlock.

2006-03-20  Jan Kiszka  <kiszka@rts.uni-hannover.de>

	* addons/rtdm/drvlib.c: fixed incongruencies in sleep and sleep_until
	  services.

2006-03-17  Albert Veli A <Albert.Veli@afconsult.com>

	* base/include/rtai_wrappers.h: wrapping macros to support sysfs in
	  RTAI fifos.c
	* base/ipc/fifos/fifos.c: support sysfs to avoid redifining fifos devs
	  at each reboot.

2006-03-17  Roberto Bucher <roberto.bucher@supsi.ch>

	* rtai-lab/*: Introduced some nice new features from Peter Brier.
	* rtai-lab/scilab/*: Substituted the general structure "devstruct" 
	  with a specific struct for each scicos block.

2006-03-07  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_prinher.h: inlines to support full priority
	  inheritance and dynamic ceiling.
	* base/include/rtai_sem.h, rtai_sched.h: added queue element for
	  resources queue.
	* base/arch/i386/Kconfig: added parameter to configure either
	  priority inheritance or ceiling.
	* base/sched/sched.c: added res queue initialisations.
	* base/ipc/sem/sem.c: support priority inheritance/ceiling.
	* base/ipc/msg/msg.c: support priority inheritance/ceiling.
	* base/ipc/mbx/mbx.c: revised and semplified.
	* base/ipc/netrpc/netrpc.c: revised the async mbx use as for mbx.c.

2006-02-22  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/calibration/calibrate-module.c, calibrate.c and
	  calibrate.h: added in kernel calibration for both RTAI own tasks 
	  and hardened kthreads.
	* base/arch/i386/calibration/runinfo: use ksched always, i.e. the
	  overall RTAI scheduler.

2006-02-21  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_sanity.h: gcc-4.x.x is allowed now.
	* base/include/rtai_schedcore.h and base/include/asm-i386/rtai_hal.h:
	  cleared volatiles in inlined functions declaration to avoid gcc-4 
	  warnings.
	* base/include/asm-i386/rtai_lxrt.h: macros for copy_to/from reworked
	  to avoid gcc-4 warnings.
	* base/ipc/fifos/fifos.c, base/ipc/mq/mq.c and base/ipc/msg/msg.c:
	  use copy_from/to macros found in base/include/asm-i386/rtai_lxrt.h 
	  to avoid gcc-4 warnings.

2006-02-19  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/rtdm/drvlib.c and rtdm_drvlib.h: aligned to the latest.

2006-02-17  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: WAKE_UP_TASKs macro takes care of keeping Linux
	  and RTAI task rt_priority consistently. It affects give_back_to_linux
	  also. For the moment optionally settable with the hidden internal
	  macro: NEW_WAKE_UP_TASKs.

2006-02-11  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_tasklets.h and base/tasklets/tasklets.c: added per
	  cpu timers managers and lists for better MP scalability.
	* base/sched/sched.c: force suspension of released kthreads even if 
	  they own resources, this makes them behave as RTAI own kernel tasks.

2006-02-08  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* doc/doxygen/*.dox: everything revised or rewritten.

2006-02-03 RTAI-3.3 released.

2006-02-01  Roberto Bucher  <roberto.bucher@supsi.ch>

	* rtai-lab/scilab/macros/RTAI/RT_templates/rtai.mak: Added flag
          "-D_GNU_SOURCE" to CFLAGS.
	* rtai-lab/matlab/rtai.tmf: Added flag "-D_GNU_SOURCE" to CFLAGS.
	* rtai-lab/scilab/macros/RTAI/rtai_step: Eliminated an unused variable

2005-01-31  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: exploit anticipating preemption disable when
	  stealing from Linux to transition to hard real time, if available.

2005-01-16  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/arch/i386/Kconfig: some layout reordering, tasklets help
	  scripts extended to explain signals.
	* base/include/rtai_signal.h: header for the new added support of
	  async signals.
	* base/tasklets/signal.c: new added support for async signals,
	  kernel/user space alike.

2005-01-14  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/api.c: return the registration count when a named and 
	  counted object is deregistered; before this fix the registration
	  index was returned (N.B.: error introduced with the new hashed
	  registration).

2005-01-13  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_usi.h: coded atomic_cmpxchg specifically for
	  user space, it helps C++.

2005-01-13  Bernd Suessmilch <Bernd.Suessmilch@uibk.ac.at>

	* testsuite/user/switches/switch.c: fixed a misplaced sem creation.

2005-01-08  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_atomic.h: modified to solve the name
	  conflict generated by the adoption of the "atomic_cmpxchg" define
	  by Linux-2.6.15 also.

2005-01-05  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: care of the timer type when checking LATCH 
	  at starting the UP periodic timer.

2005-01-04  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_lxrt.h   and 
	* base/include/asm-x86_64/rtai_lxrt.h and
	* base/sched/sched.c: make using immediate syscalls in hard/soft 
	  switches arch dependent.

2005-01-03  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_tasklets.h, rtai_sched.h, rtai_types.h: redefined
	  types to support long timed list for both 2.4.xx and 2.6.xx. The
	  previous layout broke C++ usage for the use of "new" in a Linux
	  header (remarked by Roberto Bucher).
	* base/addons/rtdm/core.c, device.c: aligned to the latest.
	* base/addons/drivers/16550A/16550A.c: better types for a few
	  declarations.
	* base/sched/sched.c: cpu assignment should care of long timed lists;
	  force oneshot mode if period is zero.

2005-01-03  Roberto Bucher  <roberto.bucher@supsi.ch>

        * rtai-lab/scilab/macros/RTAI/rtai_square.sci: Solved problem with "bias".

2005-01-01  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_tasklets.h: separate but consistent definitions
	  of the tasklet structure in kernel and user space, to avoid problems
	  with long timed lists types.
	* base/include/rtai_sched.h, rtai_types.h: moved types definitions
	  for long timed lists from types.h to sched.h.
	* base/include/rtai_schedcore.h: simplified inlines for timed lists
	  management, unifying as far as possible.
	* base/tasklets/tasklets.c: simplified inlines for timed lists
	  management, unifying as far as possible.
	* base/sched/sched.c: enforce oneshot timer mode when a zero period
	  is passed to start_rt_timer.

2005-12-29  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/include/rtai_tasklets.h: extended to support binary tree
	  for long timed lists.
        * base/tasklet/tasklets.c: extended to support binary tree ordering 
	  for long timed lists.

2005-12-28  Paolo Mantegazza <mantegazza@aero.polimi.it>

        * base/arch/i386/Kconfig: added new config parameters for rtc and 
	  long timed lists.
	* base/arch/i386/hal/hal.immed: care of external pic in setting
	  gates for direct vectoring of interrupts.
	* base/arch/i386/hal/rtc.c: added dispatch/dontdispatch support
	  to use the RTC as a periodic timer for RTAI schedulers.
	* base/include/rtai_schedcore.h: extended to support binary tree
	  ordering for long timed lists.
	* base/include/asm-i386/rtai_lxrt.h: added definitions for using
	  the RTC.
	* base/sched/sched.c: split plain soft hard/soft transitions
	  wakeups; added starting/stopping of RTC timers.

2005-12-22  Marco Morandini  <morandini@aero.polimi.it>

        * addons/rtdm/*: RTAI based RTDM support verified against all of 
	  the RTAI examples available within the latest RTNet SVN. This 
	  completes base RTDM testing, that has been already verified to 
	  work also with RTDM based 16550A.

2005-12-22  Roberto Bucher  <roberto.bucher@supsi.ch>

        * rtai-lab/matlab/rtmain.c: Applied patch from Marco Romagnoli and
	  modification from Paolo Mantegazza.

2005-12-22  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* addons/rtdm/module.c: all functions made 0 type, RTDM cares to
	  act according to hard/soft mode appropriately (Jan sweared it).
	* base/sched/sys.c: add recovery of hard mode also before direct 
	  LXRT calls.

2005-12-20  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c: in oneshot mode read the interrupt time 
	  immediately and just once upon entering the timer_handler.

2005-12-20  Bernd Suessmilch <Bernd.Suessmilch@uibk.ac.at>

	* Kconfig/configure.in:
	   configuration support for using Linux syscall within LXRT

2005-12-20  Pierangelo Masarati <masarati@aero.polimi.it>

	* configure.in:
	   reworked scheduler configuration to note that there are only
	   two schedulers, and they must always be enabled

2005-12-19  Pierangelo Masarati <masarati@aero.polimi.it>

	* base/arch/i386/calibration/setsmi.in:
	   added scripts to set/reset the smi calibration module

2005-12-16  Bernd Suessmilch <Bernd.Suessmilch@uibk.ac.at>

	* /base/arch/i386/patches/hal-linux-2.4.32-i386-1.0-00.patch: fixed 
	   a missing header files in include/linux/ipipe.h that breaks 
	   Linux making when ipipe statistics are collected.

2005-12-16  Marcel Groothuis <marcelg-rtai@scintilla.utwente.nl>

	* /base/include/rtai_tasklets.h: fixed type clashes in tighter
	  C++ checks.

2005-12-15  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/sched/sched.c: in 2.4.xx SMP reuse the old way of waking
	   up tasks going soft by using the RTAI threads manager (thread_m).

2005-12-12  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/sched/sched.c and sys.c: kernel versions dependence for
	   2.4.xx split at 2.4.32 now.
	* /base/arch/i386/hal/hal.immed: as above.

2005-12-10  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/sched/sched.c: added a missing test on the CPU to run a task 
	  on for UP in start_stop_kthread.

2005-12-08  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/sched/sched.c: avoid stopping hard timers if not running yet.

2005-12-04  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /base/sched/sched.c: added inquiries for hard timer tick count.
	* /base/include/rtai_sched.h and rtai_lxrt.h: added declaration for
	  inquiries of hard timer tick count.

2005-11-28  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /addons/fusion/skins/rtdm/module.c: force deferred rescheduling
	  from within RTDM interrupt handlers. They are unsuitable for
	  immediate mode.

2005-11-23  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* /addons/fusion/drivers/16550A: 16550A.c fixed a likely bug in
	  config setting (this could turn to just a reminder for something 
	  else).
	* /addons/fusion/skins/rtdm/rtdm_driver.h: simplified useless code
	  for absolute timeouts.
	* /addons/fusion/skins/rtdm/xn.h: use RTAI proper kernel lock in
	  place of nklock; needed for events to be atomic with their own
	  sem calls.

2005-11-22  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/sched/sched.c and api.c: added a generic support for RTC 
	  interrupts from user space, to allow having an easy to use hard
	  periodic timer for many useful things.

2005-11-21  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* base/addons/fusion/*: updated to the latest.
	* base/addons/fusion/skins/rtdm: reworked RTAI support, user space
	  syscalls make an LXRT extension and coded as usual.

2005-11-07  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* added rtai_fusion.h to support some basic FUSION stuff needed by
	  RTAI_TRIOSS avoiding name clashes. As a side note RTAI_TRIOSS has
 	  demonstrated to work in a not so trivial integration test using 
	  native FUSION, RTDM and, naturally, RTAI.

2005-11-06  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* added support for RTC clock.

2005-11-04  Paolo Mantegazza <mantegazza@aero.polimi.it>

	* overall update to support RTAI duo and trio operating modes.

2005-10-11  Pierangelo Masarati <masarati@aero.polimi.it>

	* fix configure.in to auto-detect RTAI HAL (old/newgen)
	  to be used.

2005-10-09  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* overall update to support both ipipe and adeos. Details will follow
	  after testing on more than a single machine. Configure file to be
	  fixed ASAP. Ipipe patch for linux2.6.13 will follow after more
	  testing changes for RTAI.

2005-09-25  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_hal.h: added conditional support for 
	  x86 task priority registers: in switching back and forth Linux, 
	  inline and macro for anything a user might want to do on her/his
	  own, utility to initialise high irqs Linux does not know; requires
	  local APIC.
	* base/arch/i386/hal/hal.*: uses taskpri when enabled.
	* base/sched/sched.c: uses taskpri when enabled.

2005-09-06  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/sched/sched.c: changed oneshot programming to improve 
	  latencies for relatively long time span firings with uncalibrated 
	  frequencies, by introducing sub time steps also when the APIC 
	  timer is used.
	* base/include/asm-i386/rtai_lxrt.h: changed value of the 
	  ONESHOT_SPAN macro to support what above.

2005-09-01  Pierangelo Masarati <masarati@aero.polimi.it>

        * addons/fusion/*: first import of rtdm support

2005-09-01  Paolo Mantegazza  <mantegazza@aero.polimi.it>

        * base/sched/sched.c: modified startup of RTAI proper kernel tasks.
        * base/ipc/netrpc/netrpc.c: modified local mbx_send_if specific 
	  support, used in async rpcing.

2005-08-28  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/include/rtai_netrpc.h: modified inlined calls for more across
	  archiectures consisency.
	* base/ipc/netrpc/netrpc.c: added ksocket services for architectures
	  not exporting socketcall.
	* base/ipc/shm/shm.c and base/sched/sys.c: use max_slots variable and
	  not MAX_SLOTS macro, they differ in hashed registry.
	* base/sched/api.c: added a missing loop over registered objects to be
	  released at task existing, export max_slots, clean unused code.

2005-08-26  Daniele Gasperini  <gasperin@elet.polimi.it> and
            Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/include/rtai_netrpc.h,rtai_proxies.h,rtai_sched.h,rtai_msg.h,
	  rtai_schedcore.h: argument for kernel tasks/threads passed from 
	  int to long, to countinue allowing address passing in x86_64.
	* base/sched/api.c,sched.c,sched.immed,sys.c: made to comply using
	  a long arg for kernel tasks/threads.
	* base/tasklets/tasklets.c; made to comply using a long arg for 
	  kernel tasks/threads
	* base/ipc/msg/msg.c: made to comply using a long arg for kernel
	* base/wd/wd.c: made to comply using a long arg for kernel 
	  tasks/threads

2005-08-25  Daniele Gasperini  <gasperin@elet.polimi.it> and
            Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/arch-x86_64/hal/hal.c: updated to the latest non arch dependent
	  improvments, made direct interrupt at the gate level work.
	* base/include/asm-x86_64/*.*: as above.

2005-08-24  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/ipc/bits/bits.c: changed during function execution storage
	  place of bits: fun and mask, from retval to a local stack buffer,
	  to avoid trouble with 64 bits.

2005-08-16  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* include/asm-i386/rtai_lxrt.h: got rid of the long time unused local
          copy of switch_to, everything kept only as in Linux now.
	* base/sched/sched.c: rework of hard/soft/hard transitions, to help 
          2.4.xx have them better too.
	* include/rtai_schedcore.h: modified Linux tasks pending macro to 
	  support hard/soft/hard transition changes.
	* base/arch/i386/patches: all changed with immediate indirection to
	  the RTAI hard interrupt dispatcher in hal.c; verified that 
	  improvements are a bit beyond the mere us slicing in long terms 
	  usage.
	* base/arch/i386/hal/hal.c: adapted to changed patches.

2005-08-03  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* include/asm/rtai_lxrt.h: defined rt_copy-from/to and rt_put/get (for 
	  user space data exchange) as arch dependent.
	* ipc/bits.c-mbx.c-netrpc.c-tbx.c-tasklet.c: used rt_copy-from/to, 
	  rt_put/get (for user space data exchange) defined as arch dependent 
	  in asm/rtai_lxrt.
	* base/sched/api.c: used rt_copy-from/to, rt_put/get (for user space 
	  data exchange) defined as arch dependent in asm/rtai_lxrt.
	* base/sched/sched.c: modified the way is_hard is used, 0-soft, 1-hard,
	* base/sched/sys.c: used rt_copy-from/to, rt_put/get (for user space
	  data exchange) defined as arch dependent in asm/rtai_lxrt; modified 
	  the way is_hard is used, 0-soft, 1-hard, -1-tobehard; fixed a bug in 
	  the resizing of per task intertask messaging buffers.

2005-07-27  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* include/rtai_lxrt.h: LXRT enc/decoding restructured to make room 
	  for something else.
	* base/sched/sys.c: made possible to mix different user space calls, 
	  i.e.: both RTAI specific an Linux syscalls.

2005-07-23  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* sched/sys.c: returns the pointer to the a newly initilised linux
	  syscalls server and resume the server thread.
	* sched/api.c: linux syscalls server support functions return a
	  pointer to the appropriate task.
	* sched/sched.c: reinitialise linux syscalls server at each call,
	  as returned by the linux syscall server support function in api.c,
	  so that it is not called again in case it has gone away.
	* include/rtai_sched.h: redeclare linux syscall functions to comply
	  with the above changes;
	* include/rtai_lxrt.h: modify the user part of the syscall server to
	  comply with the above changes.

2005-07-21  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* sched/api.c: fixed a wrong test in function "hash_rem_adr" that
	  caused an unconditional deletion of counted registrations also.

2005-07-15  Ignacio Garc�a P�rez <iggarpe@terra.es>

	* base/include/asm-i386/rtai_hal.immed: fixed a very bad misnaming 
	  in interrupt flags manipulating macros.

2005-07-14  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/include/asm-i386/rtai_lxrt.h: if using Linux syscall for RTAI 
	  proper syscalls is enabled then we do exactly what Linux does.

2005-07-12  Paul <bdi-emc@ntlworld.com>

	* /base/include/asm-i386/rtai_atomic.h: added likely/unlikely support to
	  avoid problems with < gcc-2.96.

2005-07-10  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/include/asm/rtai_fpu.h: extensively revised/rewritten, 
	  related conceptual changes and new names reflected in:
	  asm-i386/rtai_sched.h, sched/sched.immed, sched/sys.c, tasklets.c,
	  arch/i386/hal/hal.immed.
	* base/include/rtai_schedcore.h: unified all definitions of 
	  RTAI functions args from user space in a single place, 
	  changes and new names reflected in:
	  sched/sched.immed, sched/sys.c, ipc/netrpc/netrpc.c.
	* base/sched/sys.c: revised intertask messages exchanges from 
	  user space.

2005-07-08  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/include/asm/rtai_fpu.h: preliminary cleanup, before an 
	  overall ovehauling.

2005-07-04  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/include/rtai_schedcore.h,
	* base/sched/sched.immed: reorganised and renamed optional busy wait 
	  time alignments at return from schedules.

2005-07-04  Panagiotis Issaris  <takis@gna.org>

	* base/include/{rtai_msg.h, rtai_names.h}, base/ipc/msg/msg.c: Prevent 
	  a name clash.

2005-07-03  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/include/rtai_schedcore.h: fixed wrong determination of the
	  cpu to which a readied soft task is pended.
	* base/sched/sched.immed: revised and improved managment 
	  of RTAI syscalls, following revision of the encoding of msgs 
	  read/writes.
	* base/sched/sys.c: put likely/unlikely suggestions here and there.
	* base/ipc/sem/sem.c: more consistent check in case of abnormal 
	  wakeup from rt_schedule, avoid using sem.
	* base/ipc/mbx/mbx.c: more consistent check in case of abnormal 
	  wakeup from rt_schedule, avoid using anything related to mbx.
	* base/ipc/msg/msg.c: consistent check in case of abnormal 
	  wakeup from rt_schedule, avoid using anything related to the
	  messaged task.

2005-07-01  Panagiotis Issaris <takis@gna.org>

	* configure.in: Fix the configure script when using an external Linux
	build directory.
	
2005-06-30  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/sched/sched.immed and api.c: implemnted new hashed registry
	  support.
	* /base/include/rtai_nam2num.h and rtai_registry.h: adapted to work 
	* /base/ipc/shm/shm.c: adapted to work with the new hashed registry 
	* /base/ipc/msg/msg.c: cancelled redundant dangerous dequeue_blocked.
	* /base/arch/i386/hal/hal.immed: adapted to likely changes of future
	  ADEOS patches.

2005-06-21  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/sched/sched.immed and sys.c: revised and improved managment 
	  of RTAI syscalls, following revision of the encoding of msgs 
	  read/writes.
	* base/ipc/netrpc/netrpc.c: exploits the semplification of the 
	  new encoding schedme for msgs read/writes.
	* base/include/rtai_schedcore.h: unifies an ubiquitus declaration
	  of RTAI syscalls arguments in a single place.
	* base/include/rtai_lxrt.h: simplified encoding of msgs read/writes.
	* base/include/rtai_netrpc.h: inheredits the encoding of rtai_lxrt.h,
	  with all the changes to functions declarations related to it.

2005-06-21  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/ipc/fifos/fifos.c: avoid direct initialiasation of a 
	  spinlock, conflicting with Linux 2.6.11.
	* base/include/rtai_shm.h: conditinally define the arch independent 
	  function "remap_page_range", that disappeared in Linux 2.6.11.

2005-06-21  Jan Kiszka  <kiszka@rts.uni-hannover.de>

	* base/include/asm-i386/rtai_fpu.h: FPU support must now care
	  of different versions of Linux 2.6.xx also.
	* base/include/asm-i386/rtai_shm.h: shared pages manipulation needs
	  to care of different versions of Linux 2.6.xx also.
	* base/arch/i386/hal/hal.immed: setting of Linux priority must now
	  account for different versions of Linux 2.6.xx too; rare "device
	  not available" traps updated to use new overhauled macros in 
	  asm-i386/rtai_fpu.h.
	* base/sched/sched.c and base/sched/sys.c: updated to use new
	  overhauled macros in asm-i386/rtai_fpu.h.

2005-06-21  Bernd Suessmilch  <Bernd.Suessmilch@uibk.ac.at>

	* base/sched/sched.c:
	* base/sched/sys.c: improved Linux signal catching and dispatching.
	
2005-06-17  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/include/rtai_schedcore.h: pend trasitions to soft mode
	  directly, they are all atomic protected already.
	* base/sched/sched.c: uses above and simplified the trasition to 
	  soft mode handler.

2005-06-16  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed: direct vectoring of irqs to the
	  CPU has its tail as for immediate dispatching, to help Linux in
	  the non preemptible case, i.e. under 2.4.xx. It tend to starve
	  otherwise under very very high soft real time load.

2005-06-14  Roberto Bucher  <roberto.bucher@supsi.ch>

        * rtai-lab/scilab/macros/RTAI/RTAICodeGen_.sci: Corrected problem with
	acivation from continous blocks. Better handling of "ode" functions
        * rtai-lab/scilab/devices/rtai_comedi_dio.c: Corrected problem with
	threshold in output block
	
2005-05-31  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/arch/x86_64/hal/hal.immed:
	  and
	* base/include/asm-x86_64/rtai_hal.immed: all features of the 
	  latest i386 version.

2005-05-30  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed: rt_printk uses printk directly, 
	  a sync version added also.
	  
2005-05-30  Daniele Gasperini  <gasperin@elet.polimi.it>

	* first port of what needed to use x*6_64.

2005-05-25  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/arch/i386/hal/hal.immed: trap handler modified to use 
	  unwrapped ADEOS event catching.
	* base/sched/sched.immed: all event handlers modified to use
          unwrapped ADEOS event catching; depends on the definition of the
	  macro "UNWRAPPED_CATCH_EVENT", to be defined in rtai_hal.h.
	* base/include/asm-i386/rtai_hal.immed: enabled macro to use 
	  unwrapped event catching.
	* base/arch/i386/patches: modified handle_event to avoid wrapping
	  event and related data.

2005-05-25  Roberto Bucher  <roberto.bucher@supsi.ch>

        * rtai-lab/scilab/macros/RTAI/RTAICodeGen_.sci: Added checks for the
	dialog box values
        * rtai-lab/scilab/macros/RTAI/SetTarget_.sci: Added checks for the
	dialog box values
	

2005-05-24  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/include/asm/rtai_hal.immed: do not double marking in hard 
	  real time, in cpu_realtime, the depth count is more than enough.
	* base/arch/i386/hal/hal.immed: lock out Linux directly from 
	  interrupt handlers; avoid dispatching irqs completely.
	* base/sched/sched.immed: care of avoiding Linux locking when done
	  in irq handler already, enable immediate sched on ipi without
	  dispatching.

2005-05-23  Roberto Bucher  <roberto.bucher@supsi.ch>

        * rtai-lab/scilab/rtmain.c: Support for continous blocks
        * rtai-lab/scilab/macros/RTAI/*: RTAICodeGen_.sci modified and compatible with 
	  Scilab-3.1 CVS with support for continous blocks
	  Added subdirectory "RT_templates" for tmemplate Makefiles
	  Added New function "SetTarget_.sci" to handle template Makefile and
	  continous code generation.

2005-05-18  Philippe Gerum  <rpm@xenomai.org>

	* configure.in: stop configuring if Linux REGPARMS is set.

2005-05-18  Paolo Mantegazza  <mantegazza@aero.polimi.it>

	* base/include/rtai_malloc.h: practically break any constraint in
	  dynamic memory allocation.

2005-05-13  Paolo Mantegazza  <mantegazza@aero.polimi.it>

        * base/sched/sched.immed: 
	  - changed coding of circular pending lists,
	  - pending wake up macro transferred to rtai_schedcore.h,
	  - parametrised give_back_to_linux to distinguish between raw
	    use and internal hard/soft transitions following Linux use,
	  - use ADEOS virq directly for waking up Linux tasks from RTAI.
        * base/sched/api.c: sleeping tasks wake up substituted with the more
	  general rt_task_masked_unblock, so that it becomes just a #define 
	  subcase of it.
        * base/sched/sys.c: cares of the paremetrised give_back_to_linux.
        * base/arch/i386/hal.immed: 
	  - cleaned unused/useless stuff,
	  - layout restyling,
	  - old cpu affinity state is saved no more, as it could wrongly 
	    restate an unintended mask in case of repeated calls, user must
	    care of it; to such an aim the set affinity function return the
	    previous state,
	  - optional stalling of the RTAI domain in hard mode, under control
	    of the STALL_RTAI_DOMAIN macro,
        * base/include/asm-i386/rtai_hal.immed: changes to support consistency 
	  when STALL_RTAI_DOMAIN is used.
        * base/include/rtai_schedcore.h: defines pending wake up macros for
	  any need. 
        * testsuite/kern/latency/, testsuite/user/latency/: output conforming
	  to 3.2, i.e with overall count of periodic reschedules displayed
	  also.

2005-05-03  Roberto Bucher  <roberto.bucher@supsi.ch>

        * rtai-lab/scilab/macros/RTAI/*: Added new blocks

2005-04-27  Panagiotis Issaris <panagiotis.issaris@mech.kuleuven.ac.be>
	* testsuite/{user,kernel}/{latency,preempt}/display.c: output is now 
	in tabular format and output uses the same units for each test.
	* testsuite/user/latency/display.c: show overall maximum latency.

2005-04-20  Roberto Bucher  <roberto.bucher@supsi.ch>

        * rtai-lab/scilab/macros/RTAI/*: Scicos ports are now set automatically
	* rtai-lab/scilab/devices/*: library files modified for port set automatically
	* rtai-lab/scilab/example/tes.cos: Modifies with the new scicos blocks

2005-04-13  Paolo Mantegazza  <mantegazza@aero.polimi.it>

        * begin new development cycle, aligning to stable vulcano, i.e. 3.2.
